searchNodes=[{"ref":"Chunky.html","title":"Chunky","type":"module","doc":"Extended chunking and enumeration manipulations. Functions Chunky.permutations/1 - Generate all permutations of a set of values, with no duplication Chunky.permutations_size/1 - Calculate the size of a permutation result from Chunky.permutations/1 Chunky.combinations/2 - Generate combinations of a set of values, with no duplication Chunky.combinations_size/2 - Calculate the size of a combanation result from Chunky.combinations/2 Chunky.chunk_length/2 - Chunk an enumerable into a list of specific length chunks For combinations and permutations, it can be helpful compare the differences: UnorderedOrdered No ReplacementChunky.combinations/2Chunky.permutations/1 Replacementunsupportedunsupported And expected outputs from simple string parameters: UnorderedOrdered No Replacement[ &quot;abc&quot;, &quot;abd&quot;, &quot;acd&quot;, &quot;bcd&quot;][&quot;abc&quot;, &quot;acb&quot;, &quot;bac&quot;, &quot;bca&quot;, &quot;cab&quot;, &quot;cba&quot;] Replacement"},{"ref":"Chunky.html#chunk_length/2","title":"Chunky.chunk_length/2","type":"function","doc":"Break a set of values into smaller chunks of a specific length. iex&gt; Chunky.chunk_length([1, 2, 3, 4, 5, 6], 3) [ [1, 2, 3], [4, 5, 6]] iex&gt; Chunky.chunk_length(&quot;Sphinx of black quartz, judge my vow&quot;, 5) [&quot;Sphin&quot;, &quot;x of &quot;, &quot;black&quot;, &quot; quar&quot;, &quot;tz, j&quot;, &quot;udge &quot;, &quot;my vo&quot;, &quot;w&quot;] The type of the set of values can be: a list of any type, like [1, 2, 3] or [:a, :b, %{}] a string or binary, like &quot;abcd&quot; a tuple, like {1, :b, &quot;asdf&quot;} a range, like 1..4 or 3..-1 When a set is chunked, the resulting list will contain values in the shape of the original; a chunked list will contains lists, chunked tuples will contain tuples, chunked strings will contain strings. The only exception is ranges, which will result in lists. Supported Chunking Types The following types of sets are supported for chunking: List A list with just about any kind of value can be chunked, and the result will be a list of lists: iex&gt; Chunky.chunk_length([1, 2, 3, 4, 5, 6, 7, 8], 3) [ [1, 2, 3], [4, 5, 6], [7, 8]] iex&gt; Chunky.chunk_length([:a, 1, :b, 2, :c, 3, :d, 4, :e, 5, :f, 6], 4) [ [:a, 1, :b, 2], [:c, 3, :d, 4], [:e, 5, :f, 6]] Collections, types, and other values can be in the chunked set: iex&gt; Chunky.chunk_length([~D(2019-12-05), %{a: &quot;foo&quot;}, {:tup, :le}, true], 2) [ [~D(2019-12-05), %{a: &quot;foo&quot;}], [{:tup, :le}, true]] String/Binary Chunked strings are returned as a list of strings. Chunky works with full UTF-8, including multi-code point glyphs like emojis and variable emojis. iex&gt; Chunky.chunk_length(&quot;abcdefghijklmnop&quot;, 7) [ &quot;abcdefg&quot;, &quot;hijklmn&quot;, &quot;op&quot;] iex&gt; Chunky.chunk_length(&quot;😀🤷🏽‍♀️⭐️℉😐&quot;, 3) [&quot;😀🤷🏽‍♀️⭐️&quot;, &quot;℉😐&quot;] Tuple When tuples are chunked, the resulting list will also contain tuples. As part of the chunking process the original tuple is converted to a list, before the final values are re-assembled into tuples. Like working with lists, tuples can contain any values: iex&gt; Chunky.chunk_length({:a, :b, :c, :d, :e, :f, :g, :h, :i, :j}, 4) [ {:a, :b, :c, :d}, {:e, :f, :g, :h}, {:i, :j}] iex&gt; Chunky.chunk_length({:task, ~D(2019-12-09), %{value: &quot;timer&quot;}, true, 123, &quot;foo&quot;}, 2) [ {:task, ~D(2019-12-09)}, {%{value: &quot;timer&quot;}, true}, {123, &quot;foo&quot;}] Ranges Ranges can be used to create chunks over ordered lists of numbers. Before chunking the provided range is converted into a list. Increasing or decreasing ranges are supported. iex&gt; Chunky.chunk_length(1..20, 5) [ [1, 2, 3, 4, 5], [6, 7, 8, 9, 10], [11, 12, 13, 14, 15], [16, 17, 18, 19, 20]] iex&gt; Chunky.chunk_length(10..-10, 3) [ [10, 9, 8], [7, 6, 5], [4, 3, 2], [1, 0, -1], [-2, -3, -4], [-5, -6, -7], [-8, -9, -10] ]"},{"ref":"Chunky.html#combinations/2","title":"Chunky.combinations/2","type":"function","doc":"Generate the set of combinations from a set of values. The type of the set of values can be: a list of any type, like [1, 2, 3] or [:a, :b, %{}] a string or binary, like &quot;abcd&quot; a tuple, like {1, :b, &quot;asdf&quot;} a range, like 1..4 or 3..-1 This is not lazy generated, so a combination of a large set may take awhile. Keep in mind that the total number of combinations of k length for a set of n values is: n! ---------- k!(n - k)! When a set is generated, the resulting list will contain values in the shape of the original; a combination from a list will contains lists, combination from tuples will contain tuples, combination from strings will contain strings. The only exception is ranges, which will result in lists. So, for instance, a combination from a string will result in a list of strings. Chunky should handle Unicode just fine: iex&gt; Chunky.combinations(&quot;😀★⍵😀🤷🏽‍♀️&quot;, 3) [&quot;😀★⍵&quot;, &quot;😀★😀&quot;, &quot;😀★🤷🏽‍♀️&quot;, &quot;😀⍵😀&quot;, &quot;😀⍵🤷🏽‍♀️&quot;, &quot;😀😀🤷🏽‍♀️&quot;, &quot;★⍵😀&quot;, &quot;★⍵🤷🏽‍♀️&quot;, &quot;★😀🤷🏽‍♀️&quot;, &quot;⍵😀🤷🏽‍♀️&quot;] Supported Combinations The Chunky.combinations/2 function can work with sets of any size (memory and time permitting). Examples that follow usually use sets with a length of 2 or 3 for ease of documentation. The following types of sets are supported as combinations: List A list with just about any kind of value can be permuted, and the result will be a list of lists: iex&gt; Chunky.combinations([1, 5, 7, 11, 27], 3) [[1, 5, 7], [1, 5, 11], [1, 5, 27], [1, 7, 11], [1, 7, 27], [1, 11, 27], [5, 7, 11], [5, 7, 27], [5, 11, 27], [7, 11, 27]] iex&gt; Chunky.combinations([:a, &quot;b&quot;, 3, 26.2], 2) [ [:a, &quot;b&quot;], [:a, 3], [:a, 26.2], [&quot;b&quot;, 3], [&quot;b&quot;, 26.2], [3, 26.2] ] Collections, types, and other values can be combined as well: iex&gt; Chunky.combinations([~D(2019-12-05), %{a: &quot;foo&quot;}, {:tup, :le}, [1, 2, 3]], 3) [ [~D[2019-12-05], %{a: &quot;foo&quot;}, {:tup, :le}], [~D[2019-12-05], %{a: &quot;foo&quot;}, [1, 2, 3]], [~D[2019-12-05], {:tup, :le}, [1, 2, 3]], [%{a: &quot;foo&quot;}, {:tup, :le}, [1, 2, 3]] ] String/Binary Combined strings are returned as a list of strings. Chunky works with full UTF-8, including multi-code point glyphs like emojis and variable emojis. iex&gt; Chunky.combinations(&quot;abcd&quot;, 2) [&quot;ab&quot;, &quot;ac&quot;, &quot;ad&quot;, &quot;bc&quot;, &quot;bd&quot;, &quot;cd&quot;] iex&gt; Chunky.combinations(&quot;😀🤷🏽‍♀️⭐️🧁🦴&quot;, 3) [ &quot;😀🤷🏽‍♀️⭐️&quot;, &quot;😀🤷🏽‍♀️🧁&quot;, &quot;😀🤷🏽‍♀️🦴&quot;, &quot;😀⭐️🧁&quot;, &quot;😀⭐️🦴&quot;, &quot;😀🧁🦴&quot;, &quot;🤷🏽‍♀️⭐️🧁&quot;, &quot;🤷🏽‍♀️⭐️🦴&quot;, &quot;🤷🏽‍♀️🧁🦴&quot;, &quot;⭐️🧁🦴&quot; ] Tuple When tuples are combined, the resulting list will also contain tuples. As part of the combination the original tuple is converted to a list, before the final values of the combination are re-assembled into tuples. Like working with lists, tuples can contain any values: iex&gt; Chunky.combinations({:a, :b, :c, :d, :e}, 3) [ {:a, :b, :c}, {:a, :b, :d}, {:a, :b, :e}, {:a, :c, :d}, {:a, :c, :e}, {:a, :d, :e}, {:b, :c, :d}, {:b, :c, :e}, {:b, :d, :e}, {:c, :d, :e} ] iex&gt; Chunky.combinations({:task, ~D(2019-12-09), %{value: &quot;timer&quot;}, [1, 2, 3]}, 3) [ {:task, ~D[2019-12-09], %{value: &quot;timer&quot;}}, {:task, ~D[2019-12-09], [1, 2, 3]}, {:task, %{value: &quot;timer&quot;}, [1, 2, 3]}, {~D[2019-12-09], %{value: &quot;timer&quot;}, [1, 2, 3]} ] Ranges Ranges can be used to create combinations over ordered lists of numbers. Before combination the provided range is converted into a list. Increasing or decreasing ranges are supported. iex&gt; Chunky.combinations(3..6, 2) [ [3, 4], [3, 5], [3, 6], [4, 5], [4, 6], [5, 6] ] iex&gt; Chunky.combinations(-10..-13, 3) [ [-10, -11, -12], [-10, -11, -13], [-10, -12, -13], [-11, -12, -13] ] Examples iex&gt; Chunky.combinations([4, 3, 4, 3], 3) [[4, 3, 4], [4, 3, 3], [4, 4, 3], [3, 4, 3]] iex&gt; Chunky.combinations(&quot;abcd&quot;, 2) [&quot;ab&quot;, &quot;ac&quot;, &quot;ad&quot;, &quot;bc&quot;, &quot;bd&quot;, &quot;cd&quot;] iex&gt; Chunky.combinations({:a, :b, :c}, 1) [ {:a}, {:b}, {:c}] iex&gt; Chunky.combinations(2..-2, 3) [ [2, 1, 0], [2, 1, -1], [2, 1, -2], [2, 0, -1], [2, 0, -2], [2, -1, -2], [1, 0, -1], [1, 0, -2], [1, -1, -2], [0, -1, -2]]"},{"ref":"Chunky.html#combinations_size/2","title":"Chunky.combinations_size/2","type":"function","doc":"Compute the size of the result of calling Chunky.combinations/2, without actually running a combination. This is particularly useful, as the number of results of a combination of k elements from a set of n, grows as: n! ---------- k!(n - k)! This can be a quick sanity check before running a permutation. Works with all of the parameters that work with Chunky.permutations/1, as a drop in replacement. Uses a closed form factorial to calculate the size of the list that would result from an indentical call to Chunky.permutations/1: iex&gt; Chunky.combinations_size(&quot;abcd&quot;, 2) 6 iex&gt; Chunky.combinations_size(1..10, 4) 210 iex&gt; Chunky.combinations_size({:a, :b, :c, :d, :e, :f, :g}, 5) 21 iex&gt; Chunky.combinations_size([2, 4, 6, 8, 10, 12, 14, 16, 18, 20, 22, 24, 26, 28, 30], 3) 455 See Chunky.combinations/2 for more details on supported types."},{"ref":"Chunky.html#permutations/1","title":"Chunky.permutations/1","type":"function","doc":"Generate all of the permutations, without duplicates, from a set of values. The type of the set of values can be: a list of any type, like [1, 2, 3] or [:a, :b, %{}] a string or binary, like &quot;abcd&quot; a tuple, like {1, :b, &quot;asdf&quot;} a range, like 1..4 or 3..-1 This is not lazy generated, so a permutation of a large set may take awhile. Keep in mind that the total number of permutations for a set of N values is N!. When a set is permuted, the resulting list will contain values in the shape of the original; a permuted list will contains lists, permuted tuples will contain tuples, permuted strings will contain strings. The only exception is ranges, which will result in lists. So, for instance, a permuted string will result in a list of strings. Chunky should handle Unicode just fine: iex&gt; Chunky.permutations(&quot;😀★⍵&quot;) [&quot;😀★⍵&quot;, &quot;😀⍵★&quot;, &quot;★😀⍵&quot;, &quot;★⍵😀&quot;, &quot;⍵😀★&quot;, &quot;⍵★😀&quot;] Supported Permutations The Chunky.permutations/1 function can work with sets of any size (memory and time permitting). Examples that follow usually use sets with a length of 3 for ease of documentation. The following types of sets are supported as permutations: List A list with just about any kind of value can be permuted, and the result will be a list of lists: iex&gt; Chunky.permutations([1, 2, 3]) [[1, 2, 3], [1, 3, 2], [2, 1, 3], [2, 3, 1], [3, 1, 2], [3, 2, 1]] iex&gt; Chunky.permutations([:a, &quot;b&quot;, 3]) [ [:a, &quot;b&quot;, 3], [:a, 3, &quot;b&quot;], [&quot;b&quot;, :a, 3], [&quot;b&quot;, 3, :a], [3, :a, &quot;b&quot;], [3, &quot;b&quot;, :a] ] Collections, types, and other values can be permuted as well: iex&gt; Chunky.permutations([~D(2019-12-05), %{a: &quot;foo&quot;}, {:tup, :le}]) [ [~D[2019-12-05], %{a: &quot;foo&quot;}, {:tup, :le}], [~D[2019-12-05], {:tup, :le}, %{a: &quot;foo&quot;}], [%{a: &quot;foo&quot;}, ~D[2019-12-05], {:tup, :le}], [%{a: &quot;foo&quot;}, {:tup, :le}, ~D[2019-12-05]], [{:tup, :le}, ~D[2019-12-05], %{a: &quot;foo&quot;}], [{:tup, :le}, %{a: &quot;foo&quot;}, ~D[2019-12-05]] ] String/Binary Permuted strings are returned as a list of strings. Chunky works with full UTF-8, including multi-code point glyphs like emojis and variable emojis. iex&gt; Chunky.permutations(&quot;abc&quot;) [&quot;abc&quot;, &quot;acb&quot;, &quot;bac&quot;, &quot;bca&quot;, &quot;cab&quot;, &quot;cba&quot;] iex&gt; Chunky.permutations(&quot;😀🤷🏽‍♀️⭐️&quot;) [ &quot;😀🤷🏽‍♀️⭐️&quot;, &quot;😀⭐️🤷🏽‍♀️&quot;, &quot;🤷🏽‍♀️😀⭐️&quot;, &quot;🤷🏽‍♀️⭐️😀&quot;, &quot;⭐️😀🤷🏽‍♀️&quot;, &quot;⭐️🤷🏽‍♀️😀&quot; ] Tuple When tuples are permuted, the resulting list will also contain tuples. As part of the permutation the original tuple is converted to a list, before the final values of the permutation are re-assembled into tuples. Like working with lists, tuples can contain any values: iex&gt; Chunky.permutations({:a, :b, :c}) [ {:a, :b, :c}, {:a, :c, :b}, {:b, :a, :c}, {:b, :c, :a}, {:c, :a, :b}, {:c, :b, :a} ] iex&gt; Chunky.permutations({:task, ~D(2019-12-09), %{value: &quot;timer&quot;}}) [ {:task, ~D[2019-12-09], %{value: &quot;timer&quot;}}, {:task, %{value: &quot;timer&quot;}, ~D[2019-12-09]}, {~D[2019-12-09], :task, %{value: &quot;timer&quot;}}, {~D[2019-12-09], %{value: &quot;timer&quot;}, :task}, {%{value: &quot;timer&quot;}, :task, ~D[2019-12-09]}, {%{value: &quot;timer&quot;}, ~D[2019-12-09], :task} ] Ranges Ranges can be used to create permutations over ordered lists of numbers. Before permutation the provided range is converted into a list. Increasing or decreasing ranges are supported. iex&gt; Chunky.permutations(3..5) [[3, 4, 5], [3, 5, 4], [4, 3, 5], [4, 5, 3], [5, 3, 4], [5, 4, 3]] iex&gt; Chunky.permutations(-10..-12) [ [-10, -11, -12], [-10, -12, -11], [-11, -10, -12], [-11, -12, -10], [-12, -10, -11], [-12, -11, -10] ] Examples iex&gt; Chunky.permutations([1, 2, 3]) [[1, 2, 3], [1, 3, 2], [2, 1, 3], [2, 3, 1], [3, 1, 2], [3, 2, 1]] iex&gt; Chunky.permutations(&quot;abc&quot;) [&quot;abc&quot;, &quot;acb&quot;, &quot;bac&quot;, &quot;bca&quot;, &quot;cab&quot;, &quot;cba&quot;] iex&gt; Chunky.permutations({:a, :b, :c}) [ {:a, :b, :c}, {:a, :c, :b}, {:b, :a, :c}, {:b, :c, :a}, {:c, :a, :b}, {:c, :b, :a} ] iex&gt; Chunky.permutations(1..-1) [ [1, 0, -1], [1, -1, 0], [0, 1, -1], [0, -1, 1], [-1, 1, 0], [-1, 0, 1]]"},{"ref":"Chunky.html#permutations_size/1","title":"Chunky.permutations_size/1","type":"function","doc":"Compute the size of the result of calling Chunky.permutations/1, without actually running a permutation. The results of a permutation of a set of n items grows at a rate of n!. This can be a quick sanity check before running a permutation. Works with all of the parameters that work with Chunky.permutations/1, as a drop in replacement. Uses a closed form factorial to calculate the size of the list that would result from an indentical call to Chunky.permutations/1: iex&gt; Chunky.permutations_size(&quot;abcd&quot;) 24 iex&gt; Chunky.permutations_size(1..10) 3628800 iex&gt; Chunky.permutations_size({:a, :b, :c, :d, :e, :f, :g}) 5040 iex&gt; Chunky.permutations_size([1, 4, 8, 10, 15, 37, 91, 113, 3345, 8765, 101010, 345678]) 479001600 See Chunky.permutations/1 for more details on supported types."},{"ref":"Chunky.Fraction.html","title":"Chunky.Fraction","type":"module","doc":"Functions for creating and manipulating fractions. Most functions will work with combinations of Fractions and Integers. All of the fraction functions work with explicit integer numerators and denominators, falling back to returning floating point number only when configured to in special circumstances. Value Coercion A subset of functions for working with fractions will automatically coerce things that look like fractions - any value that can be parsed by some version of new/1. This includes: Existing fractions %Fraction{num: 22, den:7} Integers 14 Floats 1.75 2-tuples {3, 91} Integer as String &quot;4&quot; Float as String &quot;1.35&quot; Fraction as String &quot;2/9&quot; See new/1 for more information about how values are converted to fractions. The following functions support mixed types as parameters, either positionally (like the basic math functions) or as part of a list (aggregate functions): add/3 divide/3 multiply/3 subtract/3 gt?/2 gte?/2 lt?/2 lte?/2 eq?/2 clamp/2 fractionalize/1 max_of/1 max_of/2 min_of/1 min_of/2 min_max_of/1 normalize_all/1 sort/2 sum/1 uniq/2 Creating Fractions Construct fractions from a single integer, tuple of integers, or a pair of integer parameters. new/1 - Create a Fraction from an integer, float, string, or tuple of integers new/2 - Create a Fraction from a numerator and denominator, or a float with options iex&gt; Fraction.new(3) %Fraction{num: 3, den: 1} iex&gt; Fraction.new({22, 7}) %Fraction{num: 22, den: 7} iex&gt; Fraction.new(0.25, conversion: :precision) %Fraction{num: 1, den: 4} iex&gt; Fraction.new(&quot;-33/913&quot;) %Fraction{num: -33, den: 913} iex&gt; Fraction.new(5, 11) %Fraction{num: 5, den: 11} Basic Math Standard math functions that work with two fractions, or a fraction and an integer. Options allow for automatic simplification and control over how certain operations work. add/3 - Add two fractions, or a fraction and a value compatible with new/1 divide/3 - Divide two fractions, or a fraction and a value compatible with new/1 max_of/2 - Find the larger of two fractions, or a fraction and a value compatible with new/1 min_of/2 - Find the smaller of two fractions, or a fraction and value compatible with new/1 multiply/3 - Multiply two fractions, or a fraction and a value compatible with new/1 power/3 - Take a fraction or an integer to the power of a fraction or an integer subtract/3 - Subtract two fractions, or a fraction and a value compatible with new/1 iex&gt; Fraction.new(4, 3) |&gt; Fraction.add(Fraction.new({1, 6})) |&gt; Fraction.power(2) %Fraction{num: 81, den: 36} iex&gt; Fraction.power(8, Fraction.new(1, 3)) %Fraction{num: 2, den: 1} Comparisons Binary comparisons between two fractions or a fraction and an integer. eq?/2 - Equality (==) comparison between two fractions, or a fraction and an integer gt?/2 - Greater than (&gt;) comparison between two fractions, or a fraction and an integer gte?/2 - Greater than or equal (&gt;=) comparison between two fractions, or a fraction and an integer lt?/2 - Less than (&lt;) comparison between two fractions, or a fraction and an integer lte?/2 - Less than or equal (&lt;=) comparison between two fractions, or a fraction and an integer iex&gt; Fraction.gt?(Fraction.new(7, 8), Fraction.new(8, 9)) false iex&gt; Fraction.eq?(3, Fraction.new(27, 9)) true Fraction Manipulation Manipulate the components of individual fractions. components/1 - Get the numerator and denominator of a fraction as a tuple of integers get_remainder/1 - Get fractional remainder after removing all whole values of a fraction get_whole/1 - Get whole value portion of a fraction reciprocal/2 - Inverse or reciprocal of a fraction simplify/1 - Simplify a fraction to it&#39;s reduced form split/1 - Extract the whole value portion and the remainer portion of a fraction as a tuple to_float/2 - Convert a fraction to a floating point value iex&gt; Fraction.new(88, 28) |&gt; Fraction.simplify() |&gt; Fraction.split() {3, %Fraction{num: 1, den: 7}} iex&gt; Fraction.new(22, 7) |&gt; Fraction.to_float(precision: 2) 3.14 Aggregate Functions Work with multiple fractions in aggregate. Most aggregate functions will work with Fractions, or any value that can be converted to a fraction with new/1. clamp/2 - Constrain a list of values to be within a specific range fractionalize/1 - Convert a list of fraction representations (anything that works with new/1) into Fraction structs max_of/1 - Find the largest value in a list of fractions, or literals compatible with new/1 min_of/1 - Find the smallest value in a list of fractions, or literals compatible with new/1 min_max_of/1 - Find the smallest and largest values in a list of fractions or literals compatible with new/1 normalize/2 - Convert two fractions to a common denominator normalize_all/1 - Convert a list of two or more fractions to a common denominator sort/2 - Sort a list of values as fractions sum/2 - Find the sum of a list of fractions uniq/2 - Extract unique fractions from a list of values iex&gt; Fraction.normalize(Fraction.new(22, 7), Fraction.new(4, 3)) { %Fraction{num: 66, den: 21}, %Fraction{num: 28, den: 21} } iex&gt; Fraction.max_of([&quot;3/4&quot;, {4, 5}, 1.5]) %Fraction{num: 15, den: 10} Inspection Inspect the properties of individual fractions. has_whole?/1 - Does a fraction have a whole value component? (i.e. has a total value greater than 1) is_negative?/1 - Is a fraction negative? is_positive?/1 - Is a fraction positive? is_simplified?/1 - Is a fraction in it&#39;s simplified form? is_whole?/1 - Is the fraction an exact whole number? is_zero?/1 - Is the fraction zero? iex&gt; Fraction.new(3, 18) |&gt; is_simplified?() false Integer Math Integer math functions that support fraction functions and manipulations. integer_nth_root?/3 - Determine if an integer has a specific n-th root lcm/1 - Least common multiple of a list of integers lcm/2 - Least common multiple of two integers nth_root/3 - Floating point n-th root of an integer iex&gt; 64 |&gt; Fraction.integer_nth_root?(3) {true, 4} iex&gt; Fraction.lcm([3, 4, 5]) 60 Float Math floats_equal/3 - Determine if two floats are equal, within an error bound"},{"ref":"Chunky.Fraction.html#add/3","title":"Chunky.Fraction.add/3","type":"function","doc":"Add two fractions, or a fraction and a value, and return the (optionally simplified) result. Supports Type Coercion?: ✅ Options simplify - Boolean - default false. Return result as a simplified fraction. Examples iex&gt; Fraction.add(Fraction.new(1, 2), Fraction.new(-8, 3)) %Fraction{num: -13, den: 6} iex&gt; Fraction.add(Fraction.new(3, 4), Fraction.new(3, 4), simplify: true) %Fraction{num: 3, den: 2} iex&gt; Fraction.add(Fraction.new(1, 3), 5) %Fraction{num: 16, den: 3} iex&gt; Fraction.add(2, Fraction.new(5, 4)) %Fraction{num: 13, den: 4} iex&gt; Fraction.add(&quot;2/3&quot;, Fraction.new(5, 3)) %Fraction{num: 7, den: 3}"},{"ref":"Chunky.Fraction.html#clamp/2","title":"Chunky.Fraction.clamp/2","type":"function","doc":"Constrain a list of values as fraction to only those values within the specified min and max. Values that are not yet Fractions are coerced into fractional values before processing. Supports Type Coercion?: ✅ Options min - Minimum value for constraining value list. Can be any value that is handled by new/1 max - Maximum value for constraining value list. Can be any value that is handled by new/1 min_inclusive - Boolean. Default true. Use inclusive minimum constraint (values &gt;= min), otherwise use exclusive (values &gt; min). max_inclusive - Boolean. Default true. Use inclusive maximum constraint (values &lt;= max), otherwise use exclusive (values &lt; max). Examples iex&gt; Fraction.clamp([&quot;22/7&quot;, &quot;14/7&quot;, &quot;11/7&quot;, &quot;7/7&quot;], min: 1, max: 2, inclusive_max: false) [%Fraction{num: 11, den: 7}, %Fraction{num: 7, den: 7}] iex&gt; Fraction.clamp([&quot;22/7&quot;, &quot;14/7&quot;, &quot;11/7&quot;, &quot;7/7&quot;], min: 1, max: 2, inclusive_min: false) [%Fraction{num: 14, den: 7}, %Fraction{num: 11, den: 7}]"},{"ref":"Chunky.Fraction.html#components/1","title":"Chunky.Fraction.components/1","type":"function","doc":"Extract the numerator and denominator of a fraction as a tuple of values. Examples iex&gt; Fraction.new(1, 37) |&gt; Fraction.components() {1, 37} iex&gt; Fraction.new(0, 3) |&gt; Fraction.components() {0, 3}"},{"ref":"Chunky.Fraction.html#divide/3","title":"Chunky.Fraction.divide/3","type":"function","doc":"Divide two fractions, or a fraction and a value and return the (optionally simplified) result. Supports Type Coercion?: ✅ Options simplify - Boolean - default false. Return result as a simplified fraction. Examples iex&gt; Fraction.divide(Fraction.new(3, 4), Fraction.new(-7, 2)) %Fraction{num: -6, den: 28} iex&gt; Fraction.divide(Fraction.new(28, 4), 4, simplify: true) %Fraction{num: 7, den: 4} iex&gt; Fraction.divide(60, Fraction.new(7, 12)) %Fraction{num: 720, den: 7} iex&gt; Fraction.divide(Fraction.new(11, 17), &quot;3&quot;) %Fraction{num: 11, den: 51}"},{"ref":"Chunky.Fraction.html#eq?/2","title":"Chunky.Fraction.eq?/2","type":"function","doc":"Compare a fraction with a value or fraction using equals comparison. Supports Type Coercion?: ✅ Examples iex&gt; Fraction.eq?(Fraction.new(7, 9), Fraction.new(3, 5)) false iex&gt; Fraction.eq?(3, Fraction.new(12, 4)) true iex&gt; Fraction.eq?(Fraction.new(-3, 12), -2) false"},{"ref":"Chunky.Fraction.html#floats_equal?/3","title":"Chunky.Fraction.floats_equal?/3","type":"function","doc":"Compare two floating points number using an epsilon error boundary. Example iex&gt; floats_equal?(3.11, 3.1) false iex&gt; floats_equal?(3.11, 3.1, 0.05) true"},{"ref":"Chunky.Fraction.html#fractionalize/1","title":"Chunky.Fraction.fractionalize/1","type":"function","doc":"Take a mixed list of fraction representations %Fraction{}, integer, float, string, etc), and convert all to fractions. This is not a normalization process - the resulting fractions are not guaranteed to share a denominator. Supports Type Coercion?: ✅ Example iex&gt; fractionalize([%Fraction{num: 3, den: 4}, 12, 0.25, &quot;22/7&quot;, &quot;4&quot;]) [%Fraction{num: 3, den: 4}, %Fraction{num: 12, den: 1}, %Fraction{num: 25, den: 100}, %Fraction{num: 22, den: 7}, %Fraction{num: 4, den: 1}]"},{"ref":"Chunky.Fraction.html#get_remainder/1","title":"Chunky.Fraction.get_remainder/1","type":"function","doc":"Get the fractional part left after removing any whole components from the fraction. Example iex&gt; Fraction.new(3, 45) |&gt; Fraction.get_remainder() %Fraction{num: 3, den: 45} iex&gt; Fraction.new(7, 3) |&gt; Fraction.get_remainder() %Fraction{num: 1, den: 3} iex&gt; Fraction.new(-10, 4) |&gt; Fraction.get_remainder() %Fraction{num: -2, den: 4}"},{"ref":"Chunky.Fraction.html#get_whole/1","title":"Chunky.Fraction.get_whole/1","type":"function","doc":"Get the whole component of a fraction. Examples iex&gt; Fraction.new(3, 7) |&gt; Fraction.get_whole() 0 iex&gt; Fraction.new(22, 7) |&gt; Fraction.get_whole() 3 iex&gt; Fraction.new(-10, 2) |&gt; Fraction.get_whole() -5"},{"ref":"Chunky.Fraction.html#gt?/2","title":"Chunky.Fraction.gt?/2","type":"function","doc":"Compare a fraction with a value or fraction using greater than comparison. Supports Type Coercion?: ✅ Examples iex&gt; Fraction.gt?(Fraction.new(7, 9), Fraction.new(3, 5)) true iex&gt; Fraction.gt?(3, Fraction.new(15, 4)) false iex&gt; Fraction.gt?(Fraction.new(-3, 12), -2) true"},{"ref":"Chunky.Fraction.html#gte?/2","title":"Chunky.Fraction.gte?/2","type":"function","doc":"Compare a fraction with a value or fraction using greater than or equal comparison. Supports Type Coercion?: ✅ Examples iex&gt; Fraction.gte?(Fraction.new(3, 9), Fraction.new(1, 3)) true iex&gt; Fraction.gte?(3, Fraction.new(15, 4)) false iex&gt; Fraction.gte?(Fraction.new(-3, 12), -2) true"},{"ref":"Chunky.Fraction.html#has_whole?/1","title":"Chunky.Fraction.has_whole?/1","type":"function","doc":"Determine if a fraction is greater than 1, and has a whole number component. Examples iex&gt; Fraction.new(3, 17) |&gt; Fraction.has_whole?() false iex&gt; Fraction.new(22, 7) |&gt; Fraction.has_whole?() true"},{"ref":"Chunky.Fraction.html#integer_nth_root?/3","title":"Chunky.Fraction.integer_nth_root?/3","type":"function","doc":"Determine if the n-th root of a number is a whole integer. If the result n-th root is within epsilon of a whole integer, we consider the result an integer n-th root. This calcualtion runs the fast converging n-th root at a higher epsilon than it&#39;s configured to use for comparison and testing of the result value. Options epsilon - Float. Default 1.0e-6. Error bounds for calculating float equality. Examples iex&gt; Fraction.integer_nth_root?(27, 3) {true, 3} iex&gt; Fraction.integer_nth_root?(1234, 6) {false, :no_integer_nth_root, 3.2750594908836885}"},{"ref":"Chunky.Fraction.html#is_negative?/1","title":"Chunky.Fraction.is_negative?/1","type":"function","doc":"Determine if a fraction is negative. Examples iex&gt; Fraction.new(-3, 4) |&gt; Fraction.is_negative?() true"},{"ref":"Chunky.Fraction.html#is_positive?/1","title":"Chunky.Fraction.is_positive?/1","type":"function","doc":"Determine if a fraction is positive. Examples iex&gt; Fraction.new(-3, 4) |&gt; Fraction.is_positive?() false"},{"ref":"Chunky.Fraction.html#is_simplified?/1","title":"Chunky.Fraction.is_simplified?/1","type":"function","doc":"Determine if a fraction is in simplified form. Examples iex&gt; Fraction.new(2, 4) |&gt; Fraction.is_simplified?() false iex&gt; Fraction.new(-10, 4) |&gt; Fraction.is_simplified?() false iex&gt; Fraction.new(0, 7) |&gt; Fraction.is_simplified?() false iex&gt; Fraction.new(22, 7) |&gt; Fraction.is_simplified?() true"},{"ref":"Chunky.Fraction.html#is_whole?/1","title":"Chunky.Fraction.is_whole?/1","type":"function","doc":"Determine if a fraction exactly represents a whole number, with no remainder. Examples iex&gt; Fraction.new(5, 3) |&gt; Fraction.is_whole?() false iex&gt; Fraction.new(-22, 11) |&gt; Fraction.is_whole?() true"},{"ref":"Chunky.Fraction.html#is_zero?/1","title":"Chunky.Fraction.is_zero?/1","type":"function","doc":"Does a fraction represent a zero value? Examples iex&gt; Fraction.new(3, 134) |&gt; Fraction.is_zero?() false iex&gt; Fraction.new(0, 34) |&gt; Fraction.is_zero?() true"},{"ref":"Chunky.Fraction.html#lcm/1","title":"Chunky.Fraction.lcm/1","type":"function","doc":"Find the least common multiple of two integers or a list of integers. Example iex&gt; lcm(5, 7) 35 iex&gt; lcm([3, 5, 7, 11, 13, 17]) 255255"},{"ref":"Chunky.Fraction.html#lcm/2","title":"Chunky.Fraction.lcm/2","type":"function","doc":""},{"ref":"Chunky.Fraction.html#lt?/2","title":"Chunky.Fraction.lt?/2","type":"function","doc":"Compare a fraction with a value or fraction using less than comparison. Supports Type Coercion?: ✅ Examples iex&gt; Fraction.lt?(Fraction.new(7, 9), Fraction.new(3, 5)) false iex&gt; Fraction.lt?(3, Fraction.new(15, 4)) true iex&gt; Fraction.lt?(Fraction.new(-3, 12), -2) false"},{"ref":"Chunky.Fraction.html#lte?/2","title":"Chunky.Fraction.lte?/2","type":"function","doc":"Compare a fraction with a value or fraction using less than or equal comparison. Supports Type Coercion?: ✅ Examples iex&gt; Fraction.lte?(Fraction.new(7, 9), Fraction.new(3, 5)) false iex&gt; Fraction.lte?(3, Fraction.new(15, 4)) true iex&gt; Fraction.lte?(Fraction.new(-24, 12), -2) true"},{"ref":"Chunky.Fraction.html#max_of/1","title":"Chunky.Fraction.max_of/1","type":"function","doc":"Return the maximum value in a list of fractions or values. Relative comparisons are calculated based on float converion of fractions. Supports Type Coercion?: ✅ Example iex&gt; Fraction.max_of([ Fraction.new(3, 7), Fraction.new(5, 11), Fraction.new(11, 23)]) %Fraction{num: 11, den: 23}"},{"ref":"Chunky.Fraction.html#max_of/2","title":"Chunky.Fraction.max_of/2","type":"function","doc":"Return the larger of two fractions or values. Supports Type Coercion?: ✅ Example iex&gt; Fraction.max_of( Fraction.new(3, 7), Fraction.new(11, 28) ) %Fraction{num: 3, den: 7} iex&gt; Fraction.max_of(Fraction.new(4, 3), 8.3) %Fraction{num: 83, den: 10}"},{"ref":"Chunky.Fraction.html#min_max_of/1","title":"Chunky.Fraction.min_max_of/1","type":"function","doc":"Return a tuple with the smallest and largest fractions from a list. Supports Type Coercion?: ✅ Example iex&gt; Fraction.min_max_of([ Fraction.new(3, 7), Fraction.new(5, 11), Fraction.new(11, 23)]) { %Fraction{num: 3, den: 7}, %Fraction{num: 11, den: 23} }"},{"ref":"Chunky.Fraction.html#min_of/1","title":"Chunky.Fraction.min_of/1","type":"function","doc":"Find the minimum value in a list of fractions or vaules. Relative comparisons are calculated based on float conversion of fractions. Supports Type Coercion?: ✅ Example iex&gt; Fraction.min_of([ Fraction.new(3, 7), Fraction.new(5, 11), Fraction.new(11, 23)]) %Fraction{num: 3, den: 7}"},{"ref":"Chunky.Fraction.html#min_of/2","title":"Chunky.Fraction.min_of/2","type":"function","doc":"Return the smaller of two fractions, or a fraction and an alternate encoding (like float, string, or integer). Supports Type Coercion?: ✅ Example iex&gt; Fraction.min_of( Fraction.new(3, 7), Fraction.new(11, 28) ) %Fraction{num: 11, den: 28} iex&gt; Fraction.min_of( Fraction.new(22, 7), &quot;3/7&quot;) %Fraction{num: 3, den: 7} iex&gt; Fraction.min_of(0.5, Fraction.new(-3, 5)) %Fraction{num: -3, den: 5} iex&gt; Fraction.min_of(Fraction.new(3), &quot;22/7&quot;) %Fraction{num: 3, den: 1}"},{"ref":"Chunky.Fraction.html#multiply/3","title":"Chunky.Fraction.multiply/3","type":"function","doc":"Multiply two fractions, or a fraction and a value and return the (optionally simplified) result. Supports Type Coercion?: ✅ Options simplify - Boolean - default false. Return result as a simplified fraction. Examples iex&gt; Fraction.multiply(Fraction.new(3, 7), Fraction.new(22, 7)) %Fraction{num: 66, den: 49} iex&gt; Fraction.multiply(Fraction.new(2, 9), 33, simplify: true) %Fraction{num: 22, den: 3} iex&gt; Fraction.multiply(4, Fraction.new(12, 5)) %Fraction{num: 48, den: 5} iex&gt; Fraction.multiply(&quot;4&quot;, Fraction.new(22, 7)) %Fraction{num: 88, den: 7}"},{"ref":"Chunky.Fraction.html#new/1","title":"Chunky.Fraction.new/1","type":"function","doc":"Convert a string encoding of an integer, float, or fraction into a fraction. Example iex&gt; Fraction.new(&quot;3&quot;) %Fraction{num: 3, den: 1} iex&gt; Fraction.new(&quot;12/7&quot;) %Fraction{num: 12, den: 7} iex&gt; Fraction.new(&quot;13 / 5&quot;) %Fraction{num: 13, den: 5} iex&gt; Fraction.new(&quot;foo/bar&quot;) {:error, :no_parsable_fraction} iex&gt; Fraction.new(&quot;3.14&quot;) %Fraction{num: 314, den: 100}"},{"ref":"Chunky.Fraction.html#new/2","title":"Chunky.Fraction.new/2","type":"function","doc":"Convert a floating point value to a fraction. There are two modes for converting values: Using precision approximation (via Float.ratio/1) Using natural conversion Natural conversion tries to find a fraction that represents the intended value of a float, while precision approximation tries to find a fractional representation of the encoded floating point value. Use the conversion flag to toggle between the two modes. Flags conversion - Atom. One of :natural or :precision Example iex&gt; Fraction.new(0.9, conversion: :natural) |&gt; to_string() &quot;9/10&quot; iex&gt; Fraction.new(0.9, conversion: :precision) |&gt; to_string() &quot;8106479329266893/9007199254740992&quot; iex&gt; Fraction.new(3.14, conversion: :natural) |&gt; to_string() &quot;314/100&quot; iex&gt; Fraction.new(3.14, conversion: :precision) |&gt; to_string() &quot;7070651414971679/2251799813685248&quot;"},{"ref":"Chunky.Fraction.html#normalize/2","title":"Chunky.Fraction.normalize/2","type":"function","doc":"Change a combination of fractions, or fractions and integers, into the same denominator. Example iex&gt; Fraction.normalize(Fraction.new(3, 4), Fraction.new(1, 7)) { %Fraction{num: 21, den: 28}, %Fraction{num: 4, den: 28} } iex&gt; Fraction.normalize(3, Fraction.new(2, 5)) { %Fraction{num: 15, den: 5}, %Fraction{num: 2, den: 5} } iex&gt; Fraction.normalize(Fraction.new(6, 4), 2) { %Fraction{num: 6, den: 4}, %Fraction{num: 8, den: 4} }"},{"ref":"Chunky.Fraction.html#normalize_all/1","title":"Chunky.Fraction.normalize_all/1","type":"function","doc":"Normalize (move to the same denominator) all of the fractions and integers in a list. Supports Type Coercion?: ✅ Examples iex&gt; Fraction.normalize_all([Fraction.new(1, 2), Fraction.new(2, 3), Fraction.new(3, 4), 7]) [ %Fraction{den: 12, num: 6}, %Fraction{den: 12, num: 8}, %Fraction{den: 12, num: 9}, %Fraction{den: 12, num: 84} ] iex&gt; Fraction.normalize_all([&quot;3/4&quot;, {7, 8}, Fraction.new(8, 16)]) [ %Fraction{num: 12, den: 16}, %Fraction{num: 14, den: 16}, %Fraction{num: 8, den: 16} ]"},{"ref":"Chunky.Fraction.html#nth_root/3","title":"Chunky.Fraction.nth_root/3","type":"function","doc":"Generalized integer nth root, from: https://github.com/acmeism/RosettaCodeData/blob/master/Task/Nth-root/Elixir/nth-root.elixir based on a fast converging Newton&#39;s Method process. Options precision - Float. Default 1.0e-7. Precision to which root is calculated. Examples iex&gt; nth_root(8, 3) 2.0 iex&gt; nth_root(27, 3) 3.0 iex&gt; nth_root(78125, 7) 5.0"},{"ref":"Chunky.Fraction.html#power/3","title":"Chunky.Fraction.power/3","type":"function","doc":"Use fractions in power/exponent calculations. The base or the power (or both) can be fractions. Fractions taken to an integer power will behave as expected: iex&gt; Fraction.power(Fraction.new(3, 4), 7) %Chunky.Fraction{den: 16384, num: 2187} Fractions or integers taken to a fractional power will not always return expected values, as most fractional powers do not have a result that can be represented as a fraction. By default the power functions will return an error value in these cases: iex&gt; Fraction.power(9, Fraction.new(7, 13)) {:error, :no_fractional_power} If you want the floating point fractional result, you can use the allow_irrational flag: iex&gt; Fraction.power(9, Fraction.new(7, 13), allow_irrational: true) 3.26454673038995 When calculating the fractional power of a value, an epsilon value is used as part of the n-th root finding and resulting analysis The epsilon determines how close to a whole number different components of the resulting fractions need to be, to be treated as whole numbers. Options simplify - Boolean. Default false. Optionally simplify the return fraction epsilon - Float. Small number used to compare how close two values are allow_irrational - Boolean. eDefault false. Allow a non-fractional (irrational) result to be returned Examples iex&gt; Fraction.power(Fraction.new(7, 32), Fraction.new(30, 5)) %Fraction{num: 117649, den: 1073741824} iex&gt; Fraction.power(Fraction.new(3, 5), 3) %Fraction{num: 27, den: 125} iex&gt; Fraction.power(4, Fraction.new(-4, 8)) %Fraction{num: 1, den: 2} iex&gt; Fraction.power(9, Fraction.new(7, 13), allow_irrational: true) 3.26454673038995"},{"ref":"Chunky.Fraction.html#reciprocal/2","title":"Chunky.Fraction.reciprocal/2","type":"function","doc":"Create the reciprocal of a fraction, optionally simplifying the result. Negative fractions will switch the sign to carry on the new numerator. Trying to take the reciprocal of a zero fraction will result in an error. Options simplify - Boolean - default false. Return result as a simplified fraction. Examples iex&gt; Fraction.new(3, 4) |&gt; Fraction.reciprocal() %Fraction{num: 4, den: 3} iex&gt; Fraction.new(-4, 40) |&gt; Fraction.reciprocal(simplify: true) %Fraction{num: -10, den: 1} iex&gt; Fraction.new(0, 3) |&gt; Fraction.reciprocal() {:error, :invalid_denominator}"},{"ref":"Chunky.Fraction.html#simplify/1","title":"Chunky.Fraction.simplify/1","type":"function","doc":"Simplify a fraction. Examples iex&gt; Fraction.new(6, 8) |&gt; Fraction.simplify() %Fraction{num: 3, den: 4} iex&gt; Fraction.new(24, 8) |&gt; Fraction.simplify() %Fraction{num: 3, den: 1} iex&gt; Fraction.new(22, 7) |&gt; Fraction.simplify() %Fraction{num: 22, den: 7}"},{"ref":"Chunky.Fraction.html#sort/2","title":"Chunky.Fraction.sort/2","type":"function","doc":"Sort a list of values. Values that are not yet Fractions are coerced into fractional values before processing. Supports Type Coercion?: ✅ Sorting is done based on floating point values of fractions. Options sorter - Function arity 2. Default &amp;&lt;=/2. Comparison to use when sorting. Examples iex&gt; Fraction.sort([&quot;22/7&quot;, 3, &quot;2.9&quot;, Fraction.new(1, 3)]) [%Fraction{num: 1, den: 3}, %Fraction{num: 29, den: 10}, %Fraction{num: 3, den: 1}, %Fraction{num: 22, den: 7}] iex&gt; Fraction.sort([&quot;22/7&quot;, 3, &quot;2.9&quot;, Fraction.new(1, 3)], sorter: &amp;&gt;=/2) [%Fraction{num: 22, den: 7}, %Fraction{num: 3, den: 1}, %Fraction{num: 29, den: 10}, %Fraction{num: 1, den: 3}]"},{"ref":"Chunky.Fraction.html#split/1","title":"Chunky.Fraction.split/1","type":"function","doc":"Break a fraction into whole and fractional parts, returning both. Examples iex&gt; Fraction.new(6, 4) |&gt; Fraction.split() {1, %Fraction{num: 2, den: 4}} iex&gt; Fraction.new(-22, 7) |&gt; Fraction.split() {-3, %Fraction{num: -1, den: 7}} iex&gt; Fraction.new(0, 3) |&gt; Fraction.split() {0, %Fraction{num: 0, den: 3}}"},{"ref":"Chunky.Fraction.html#subtract/3","title":"Chunky.Fraction.subtract/3","type":"function","doc":"Subtract two fractions, or a fraction an a value, and return the (optionally) simplified result. Supports Type Coercion?: ✅ Options simplify - Boolean - default false. Return result as a simplified fraction. Examples iex&gt; Fraction.subtract(Fraction.new(3, 5), Fraction.new(1, 5)) %Fraction{num: 2, den: 5} iex&gt; Fraction.subtract(2, Fraction.new(-6, 9), simplify: true) %Fraction{num: 8, den: 3} iex&gt; Fraction.subtract(Fraction.new(-2, 4), -5, simplify: true) %Fraction{num: 9, den: 2} iex&gt; Fraction.subtract(Fraction.new(8, 10), 0.5) %Fraction{num: 3, den: 10}"},{"ref":"Chunky.Fraction.html#sum/2","title":"Chunky.Fraction.sum/2","type":"function","doc":"Add a series of fractions and integers. Supports Type Coercion?: ✅ Options simplify - Boolean - default false. Return result as a simplified fraction. Example iex&gt; Fraction.sum([Fraction.new(3, 4), Fraction.new(5, 7), Fraction.new(8, 11), 1, Fraction.new(249, 308)]) %Fraction{num: 1232, den: 308} iex&gt; Fraction.sum([Fraction.new(3, 4), Fraction.new(5, 7), Fraction.new(8, 11), 1, Fraction.new(249, 308)], simplify: true) %Fraction{num: 4, den: 1}"},{"ref":"Chunky.Fraction.html#to_float/2","title":"Chunky.Fraction.to_float/2","type":"function","doc":"Convert a fraction to a float, optionally rounding to a specific precision. Options precision - Integer. Default 15. Number of digits of precision in float. From 0 to 15. Examples iex&gt; Fraction.new(22, 7) |&gt; to_float() 3.142857142857143 iex&gt; Fraction.new(22, 7) |&gt; to_float(precision: 2) 3.14"},{"ref":"Chunky.Fraction.html#uniq/2","title":"Chunky.Fraction.uniq/2","type":"function","doc":"Return only the unique fractions from a list of values. Values that are not yet Fractions are coerced into fractional values before processing. Supports Type Coercion?: ✅ Determining what is unique from the list of values is controlled by the by option. By default, value comparison is used, so 1/2 and 2/4 would be equal, and only one returned. If components comparison is specified, the literal numerator and denominator must match, so non-simplified, but value equal fractions would be different from one another. Options by - Either :value or :components. Default :value. Examples iex&gt; Fraction.uniq([&quot;2/4&quot;, Fraction.new(4, 2), 2, 0.5]) [%Fraction{num: 2, den: 4}, %Fraction{num: 4, den: 2}] iex&gt; Fraction.uniq([&quot;2/4&quot;, Fraction.new(4, 2), 2, 0.5], by: :components) [%Fraction{num: 2, den: 4}, %Fraction{num: 4, den: 2}, %Fraction{num: 2, den: 1}, %Fraction{num: 5, den: 10}]"},{"ref":"Chunky.Grid.html","title":"Chunky.Grid","type":"module","doc":"Functions for creating and manipulating a two dimenesional grid. Internally the grid is ordered as lists of lists, rather than a single list."},{"ref":"Chunky.Grid.html#find_index/2","title":"Chunky.Grid.find_index/2","type":"function","doc":""},{"ref":"Chunky.Grid.html#get_at/2","title":"Chunky.Grid.get_at/2","type":"function","doc":""},{"ref":"Chunky.Grid.html#get_at/3","title":"Chunky.Grid.get_at/3","type":"function","doc":""},{"ref":"Chunky.Grid.html#new/3","title":"Chunky.Grid.new/3","type":"function","doc":""},{"ref":"Chunky.Grid.html#put_all/2","title":"Chunky.Grid.put_all/2","type":"function","doc":"Add a list of point data to a grid. Points can be specified as {x, y, value} tuples or as maps of %{x: x, y: y, value: value}. Example #iex&gt; Grid.new(10, 10) |&gt; put_all([ {1, 1, &quot;#&quot;}, {3, 2, &quot;.&quot;}, ...])"},{"ref":"Chunky.Grid.html#put_at/3","title":"Chunky.Grid.put_at/3","type":"function","doc":""},{"ref":"Chunky.Grid.html#put_at/4","title":"Chunky.Grid.put_at/4","type":"function","doc":""},{"ref":"Chunky.Grid.html#valid_coordinate/2","title":"Chunky.Grid.valid_coordinate/2","type":"function","doc":""},{"ref":"Chunky.Grid.html#valid_coordinate/3","title":"Chunky.Grid.valid_coordinate/3","type":"function","doc":""},{"ref":"Chunky.Grid.html#valid_coordinate?/2","title":"Chunky.Grid.valid_coordinate?/2","type":"function","doc":""},{"ref":"Chunky.Grid.html#valid_coordinate?/3","title":"Chunky.Grid.valid_coordinate?/3","type":"function","doc":""},{"ref":"Chunky.Math.html","title":"Chunky.Math","type":"module","doc":"Extended integer and float mathematical functions and operations. Modular Arithmetic pow/3 - Integer power in modular exponentiation Integer Arithmetic factors/1 - All divisors for an integer pow/2 - Integer exponentiation prime_factors/1 - Factorize an integer into prime factors product_of_prime_factor_exponents/1 - Decompose n to prime factors of the form x^y, find product of all y Number Theory is_prime?/1 - Test if an integer is prime is_coprime?/2 - Test if two integers are coprime or relatively prime is_perfect?/1 - Test if an integer is perfect is_abundant?/1 - Test if an integer is abundant is_deficient?/1 - Test if an integer is deficient is_arithmetic_number?/1 - Test if an integer is an arithmetic number is_powerful_number?/1 - Test if an integer is a powerful number is_highly_abundant?/1 - Test if an integer is a highly abundant number is_highly_powerful_number?/1 - Test if an integer is a highly powerful number sigma/1 - Sigma-1 function (sum of divisors) sigma/2 - Generalized Sigma function for integers aliquot_sum/1 - Find the Aliquot Sum of n is_perfect_power?/1 - Is n a perfect power? is_root_of?/2 - Check if m is a k-th root of n is_perfect_square?/1 - Is n a perfect square? is_perfect_cube?/1 - Is m a perfect square? is_achilles_number?/1 - Is n an Achilles Number? totient/1 - Calculate Euler&#39;s totient for n Cryptographic Math is_b_smooth?/2 - Is n prime factor smooth up to b - all prime factors &lt;= b is_3_smooth?/1 - Predicate shortcut for is_b_smooth?(n, 3) is_5_smooth?/1 - Predicate shortcut for is_b_smooth?(n, 5) is_7_smooth?/1 - Predicate shortcut for is_b_smooth?(n, 7) is_11_smooth?/1 - Predicate shortcut for is_b_smooth?(n, 11) is_13_smooth?/1 - Predicate shortcut for is_b_smooth?(n, 13) is_17_smooth?/1 - Predicate shortcut for is_b_smooth?(n, 17) is_19_smooth?/1 - Predicate shortcut for is_b_smooth?(n, 19) is_23_smooth?/1 - Predicate shortcut for is_b_smooth?(n, 23) Number Generation next_number/2 - Use a number theory predicate to find the next integer in a sequence next_abundant/1 - Find the next abundant number after n next_deficient/1 - Find the next deficient number after n"},{"ref":"Chunky.Math.html#aliquot_sum/1","title":"Chunky.Math.aliquot_sum/1","type":"function","doc":"Find the Aliquot Sum of n. An Aliquot Sum of an integer n is the sum of the proper divisors (all divisors except n) of n. Examples iex&gt; Math.aliquot_sum(1) 0 iex&gt; Math.aliquot_sum(10) 8 iex&gt; Math.aliquot_sum(48) 76"},{"ref":"Chunky.Math.html#factors/1","title":"Chunky.Math.factors/1","type":"function","doc":"Factorize an integer into all divisors. This will find all divisors, prime and composite, of an integer. The algorithm used for factorization is not optimal for very large numbers, as it uses a multiple pass calculation for co-factors and composite factors. Example iex&gt; Math.factors(2) [1, 2] iex&gt; Math.factors(84) [1, 2, 3, 4, 6, 7, 12, 14, 21, 28, 42, 84] iex&gt; Math.factors(123456) [1, 2, 3, 4, 6, 8, 12, 16, 24, 32, 48, 64, 96, 192, 643, 1286, 1929, 2572, 3858, 5144, 7716, 10288, 15432, 20576, 30864, 41152, 61728, 123456]"},{"ref":"Chunky.Math.html#is_11_smooth?/1","title":"Chunky.Math.is_11_smooth?/1","type":"function","doc":"Check if an integer n is 11-smooth. See is_b_smooth?/2 for more details. Examples iex&gt; Math.is_11_smooth?(3) true iex&gt; Math.is_11_smooth?(40) true iex&gt; Math.is_11_smooth?(107) false iex&gt; Math.is_11_smooth?(2020) false"},{"ref":"Chunky.Math.html#is_13_smooth?/1","title":"Chunky.Math.is_13_smooth?/1","type":"function","doc":"Check if an integer n is 13-smooth. See is_b_smooth?/2 for more details. Examples iex&gt; Math.is_13_smooth?(3) true iex&gt; Math.is_13_smooth?(40) true iex&gt; Math.is_13_smooth?(107) false iex&gt; Math.is_13_smooth?(2020) false"},{"ref":"Chunky.Math.html#is_17_smooth?/1","title":"Chunky.Math.is_17_smooth?/1","type":"function","doc":"Check if an integer n is 17-smooth. See is_b_smooth?/2 for more details. Examples iex&gt; Math.is_17_smooth?(3) true iex&gt; Math.is_17_smooth?(40) true iex&gt; Math.is_17_smooth?(107) false iex&gt; Math.is_17_smooth?(2020) false"},{"ref":"Chunky.Math.html#is_19_smooth?/1","title":"Chunky.Math.is_19_smooth?/1","type":"function","doc":"Check if an integer n is 19-smooth. See is_b_smooth?/2 for more details. Examples iex&gt; Math.is_19_smooth?(3) true iex&gt; Math.is_19_smooth?(40) true iex&gt; Math.is_19_smooth?(107) false iex&gt; Math.is_19_smooth?(2020) false"},{"ref":"Chunky.Math.html#is_23_smooth?/1","title":"Chunky.Math.is_23_smooth?/1","type":"function","doc":"Check if an integer n is 23-smooth. See is_b_smooth?/2 for more details. Examples iex&gt; Math.is_23_smooth?(3) true iex&gt; Math.is_23_smooth?(40) true iex&gt; Math.is_23_smooth?(107) false iex&gt; Math.is_23_smooth?(2020) false"},{"ref":"Chunky.Math.html#is_3_smooth?/1","title":"Chunky.Math.is_3_smooth?/1","type":"function","doc":"Check if an integer n is 3-smooth. See is_b_smooth?/2 for more details. Examples iex&gt; Math.is_3_smooth?(3) true iex&gt; Math.is_3_smooth?(40) false iex&gt; Math.is_3_smooth?(107) false iex&gt; Math.is_3_smooth?(2020) false"},{"ref":"Chunky.Math.html#is_5_smooth?/1","title":"Chunky.Math.is_5_smooth?/1","type":"function","doc":"Check if an integer n is 5-smooth. See is_b_smooth?/2 for more details. Examples iex&gt; Math.is_5_smooth?(3) true iex&gt; Math.is_5_smooth?(40) true iex&gt; Math.is_5_smooth?(107) false iex&gt; Math.is_5_smooth?(2020) false"},{"ref":"Chunky.Math.html#is_7_smooth?/1","title":"Chunky.Math.is_7_smooth?/1","type":"function","doc":"Check if an integer n is 7-smooth. See is_b_smooth?/2 for more details. Examples iex&gt; Math.is_7_smooth?(3) true iex&gt; Math.is_7_smooth?(40) true iex&gt; Math.is_7_smooth?(107) false iex&gt; Math.is_7_smooth?(2020) false"},{"ref":"Chunky.Math.html#is_abundant?/1","title":"Chunky.Math.is_abundant?/1","type":"function","doc":"Determine if an integer is abundant. An abundant number is an integer n, such that the sum of all proper divisors of n (including itself) is greater than 2 * n. Alternatively, an abundant number is a number that satisfies: 𝜎(n) &gt; 2n See also; is_deficient?/1, is_perfect?/1, is_highly_abundant?/1, next_abundant/1. Examples iex&gt; Math.is_abundant?(3) false iex&gt; Math.is_abundant?(12) true iex&gt; Math.is_abundant?(945) true"},{"ref":"Chunky.Math.html#is_achilles_number?/1","title":"Chunky.Math.is_achilles_number?/1","type":"function","doc":"Check if a number is an Achilles Number. Achilles numbers are n that are powerful (see is_powerful_number?/1 but not perfect powers (see is_perfect_power?/1). See Chunky.Sequence.OEIS.Factor, sequence A052486. Examples iex&gt; Math.is_achilles_number?(70) false iex&gt; Math.is_achilles_number?(72) true iex&gt; Math.is_achilles_number?(2700) true iex&gt; Math.is_achilles_number?(784) false"},{"ref":"Chunky.Math.html#is_arithmetic_number?/1","title":"Chunky.Math.is_arithmetic_number?/1","type":"function","doc":"Determine if an integer is an arithmetic number. An arithmetic number n such that the average of the sum of the proper divisors of n is a whole integer. Alternatively, n that satisfy 𝜎(n) / 𝜏(n) == 0. Examples iex&gt; Math.is_arithmetic_number?(11) true iex&gt; Math.is_arithmetic_number?(32) false iex&gt; Math.is_arithmetic_number?(12953) true"},{"ref":"Chunky.Math.html#is_b_smooth?/2","title":"Chunky.Math.is_b_smooth?/2","type":"function","doc":"Determine if an integer n is b-smooth, a composite of prime factors less than or equal to b. Numbers can be b-smooth for any b that is prime. For instance, the number 8 is 3-smooth, as it&#39;s factors would be: 1^1 * 2^3 * 3^0, whereas 15 is not 3-smooth, as it&#39;s factors would be 1^1 * 2^0 * 3^1 * 5^1 - it has prime factors whose value is greater than 3. Shortcut Functions There are a collection of pre-defined predicate functions for checking b-smooth for the primes 3 to 23: - [`is_3_smooth?/1`](#is_3_smooth?/1) - [`is_5_smooth?/1`](#is_5_smooth?/1) - [`is_7_smooth?/1`](#is_7_smooth?/1) - [`is_11_smooth?/1`](#is_11_smooth?/1) - [`is_13_smooth?/1`](#is_13_smooth?/1) - [`is_17_smooth?/1`](#is_17_smooth?/1) - [`is_19_smooth?/1`](#is_19_smooth?/1) - [`is_23_smooth?/1`](#is_23_smooth?/1) Examples iex&gt; Math.is_b_smooth?(1944, 3) true iex&gt; Math.is_b_smooth?(101, 5) false iex&gt; Math.is_b_smooth?(705, 47) true"},{"ref":"Chunky.Math.html#is_coprime?/2","title":"Chunky.Math.is_coprime?/2","type":"function","doc":"Determine if two numbers, a and b, are co-prime. From Wikipedia: In number theory, two integers a and b are said to be relatively prime, mutually prime,[1] or coprime (also written co-prime) if the only positive integer (factor) that divides both of them is 1 Examples iex&gt; Math.is_coprime?(14, 15) true iex&gt; Math.is_coprime?(14, 21) false iex&gt; Math.is_coprime?(17, 2048) true"},{"ref":"Chunky.Math.html#is_deficient?/1","title":"Chunky.Math.is_deficient?/1","type":"function","doc":"Determine if an integer is deficient. A deficient number is an integer n, such that the sum of all proper divisors of n (including itself) is less than 2 * n. Alternatively, a deficient number is a number that satisfies: 𝜎(n) &lt; 2n See also; is_abundant?/1, is_highly_abundant?/1, is_perfect?/1, next_deficient/1. Examples iex&gt; Math.is_deficient?(1) true iex&gt; Math.is_deficient?(71) true iex&gt; Math.is_deficient?(33550336) false iex&gt; Math.is_deficient?(60) false"},{"ref":"Chunky.Math.html#is_highly_abundant?/1","title":"Chunky.Math.is_highly_abundant?/1","type":"function","doc":"Check if a number n is highly abundant. A number n is highly abundant when the sum of the proper factors of n is greater than the sum of the proper factors of any number m that is in 0 &lt; m &lt; n. Alternatively, for all natural numbers, m &lt; n ; 𝜎(m) &lt; 𝜎(n). See also; is_deficient?/1, is_perfect?/1, is_abundant?/1. Examples iex&gt; Math.is_highly_abundant?(1) true iex&gt; Math.is_highly_abundant?(5) false iex&gt; Math.is_highly_abundant?(30) true iex&gt; Math.is_highly_abundant?(2099) false iex&gt; Math.is_highly_abundant?(2100) true"},{"ref":"Chunky.Math.html#is_highly_powerful_number?/1","title":"Chunky.Math.is_highly_powerful_number?/1","type":"function","doc":"Check if a number n is a highly powerful number. Highly powerful numbers are similar in concept to highly abundant numbers. For highly powerful numbers, the product of the exponents of prime factors of the number n need to be greater than the same property for any number m, such that 0 &lt; m &lt; n. If you need a sequence of highly powerful numbers, use the A005934 sequence in Chunky.Sequence.OEIS.Factors, which uses an max/compare method for building the sequence, which is vastly more efficient than repeated calls to is_highly_powerful_number?/1. See also is_powerful_number?/1, and Highly powerful number. Examples iex&gt; Math.is_highly_powerful_number?(4) true iex&gt; Math.is_highly_powerful_number?(256) false iex&gt; Math.is_highly_powerful_number?(62208) true"},{"ref":"Chunky.Math.html#is_perfect?/1","title":"Chunky.Math.is_perfect?/1","type":"function","doc":"Determine if an integer is a perfect number. A perfect integer is an n where the sum of the proper divisors of n is equal to n. Alternatively, an n that satisfies 𝜎(n) == 2n. See also; is_abundant?/1, is_highly_abundant?/1, is_deficient?/1. Examples iex&gt; Math.is_perfect?(5) false iex&gt; Math.is_perfect?(6) true iex&gt; Math.is_perfect?(20) false iex&gt; Math.is_perfect?(33550336) true"},{"ref":"Chunky.Math.html#is_perfect_cube?/1","title":"Chunky.Math.is_perfect_cube?/1","type":"function","doc":"Check if n is a perfect cube. Perfect cubes are n such that there exists an m where m * m * m == n or m^3 == n. Examples iex&gt; Math.is_perfect_cube?(6) false iex&gt; Math.is_perfect_cube?(8000) true iex&gt; Math.is_perfect_cube?(1879080904) true"},{"ref":"Chunky.Math.html#is_perfect_power?/1","title":"Chunky.Math.is_perfect_power?/1","type":"function","doc":"Check if n is a perfect power. Perfect powers are n where positive integers m and k exist, such that m^k == n. Examples iex&gt; Math.is_perfect_power?(4) true iex&gt; Math.is_perfect_power?(100) true iex&gt; Math.is_perfect_power?(226) false"},{"ref":"Chunky.Math.html#is_perfect_square?/1","title":"Chunky.Math.is_perfect_square?/1","type":"function","doc":"Check if n is a perfect square. Perfect squares are n such that there exists an m where m * m == n. Examples iex&gt; Math.is_perfect_square?(3) false iex&gt; Math.is_perfect_square?(25) true iex&gt; Math.is_perfect_square?(123456) false"},{"ref":"Chunky.Math.html#is_powerful_number?/1","title":"Chunky.Math.is_powerful_number?/1","type":"function","doc":"Determine if an integer n is a powerful number. A powerful number is an integer n such that for all prime factors m of n, m^2 also evenly divides n. Alternatively, a powerful number n can be written as n = a^2 * b^3 for positive integers a and b; n is the product of a square and a cube. Examples iex&gt; Math.is_powerful_number?(8) true iex&gt; Math.is_powerful_number?(10) false iex&gt; Math.is_powerful_number?(800) true iex&gt; Math.is_powerful_number?(970) false"},{"ref":"Chunky.Math.html#is_prime?/1","title":"Chunky.Math.is_prime?/1","type":"function","doc":"Determine if a positive integer is prime. This function uses a Miller-Rabin primality test, with 40 iterations. Examples iex&gt; Math.is_prime?(13) true iex&gt; Math.is_prime?(233*444*727*456) false iex&gt; Math.is_prime?(30762542250301270692051460539586166927291732754961) true"},{"ref":"Chunky.Math.html#is_root_of?/2","title":"Chunky.Math.is_root_of?/2","type":"function","doc":"Check if n is any k-th root of m, where k &gt; 2. This function uses a repeated multiplication method to test if n has any power k such that n^k == m. Examples iex&gt; Math.is_root_of?(2, 8) true iex&gt; Math.is_root_of?(2, 2048) true iex&gt; Math.is_root_of?(7, 16807) true iex&gt; Math.is_root_of?(5, 16808) false"},{"ref":"Chunky.Math.html#next_abundant/1","title":"Chunky.Math.next_abundant/1","type":"function","doc":"Find the next abundant number after n. See is_abundant?/1. Examples iex&gt; Math.next_abundant(1) 12 iex&gt; Math.next_abundant(12) 18 iex&gt; Math.next_abundant(60) 66 iex&gt; Math.next_abundant(264) 270"},{"ref":"Chunky.Math.html#next_deficient/1","title":"Chunky.Math.next_deficient/1","type":"function","doc":"Find the next deficient number after n. See is_deficient?/1. Examples iex&gt; Math.next_deficient(0) 1 iex&gt; Math.next_deficient(5) 7 iex&gt; Math.next_deficient(41) 43"},{"ref":"Chunky.Math.html#next_number/2","title":"Chunky.Math.next_number/2","type":"function","doc":"Apply a number theoretic property test to integers to find the next number in a sequence. Examples iex&gt; Math.next_number(&amp;Math.is_powerful_number?/1, 49) 64 iex&gt; Math.next_number(&amp;Math.is_abundant?/1, 60) 66"},{"ref":"Chunky.Math.html#pow/2","title":"Chunky.Math.pow/2","type":"function","doc":"Integer exponentiation, x^y. This function uses pure integer methods to bypass issues with floating point precision trucation in large values using the built-in :math exponentiation functions. Example iex&gt; Math.pow(2, 10) 1024 iex&gt; Math.pow(17, 14) 168377826559400929"},{"ref":"Chunky.Math.html#pow/3","title":"Chunky.Math.pow/3","type":"function","doc":"Integer power/exponentiation in Modular Arithmetic. Examples iex&gt; Math.pow(5, 3, 13) 8 iex&gt; Math.pow(67930, 32319, 103969) 6582"},{"ref":"Chunky.Math.html#prime_factors/1","title":"Chunky.Math.prime_factors/1","type":"function","doc":"Decompose an integer to prime factors. This is not an exhaustive factorization, but a reduction to all prime factors for an integer. Examples iex&gt; Math.prime_factors(12) [1, 2, 2, 3] iex&gt; Math.prime_factors(101) [1, 101] iex&gt; Math.prime_factors(79170) [1, 2, 3, 5, 7, 13, 29] iex&gt; Math.prime_factors(233*444*727*456) [1, 2, 2, 2, 2, 2, 3, 3, 19, 37, 233, 727]"},{"ref":"Chunky.Math.html#product_of_prime_factor_exponents/1","title":"Chunky.Math.product_of_prime_factor_exponents/1","type":"function","doc":"Find the product of the exponents of the prime factors of n. This function takes the prime factors of n, such as the factors of 8 = {1, 2, 2, 2}, groups the factors and to find the exponents, such as 8 = 1^1 * 2^3, and then finds the product of the exponents, like 1 * 3. Here the product of prime factorization exponents for 8 is 3. The numbers generated by this function are related to the OEIS Sequence A005361, and the prodex function. Examples iex&gt; Math.product_of_prime_factor_exponents(8) 3 iex&gt; Math.product_of_prime_factor_exponents(100000) 25"},{"ref":"Chunky.Math.html#sigma/1","title":"Chunky.Math.sigma/1","type":"function","doc":"Calculate the sigma-1 (or σ1(n)), also known as sum-of-divisors of an integer. This is all of the divisors of n summed. Example iex&gt; Math.sigma(70) 144 iex&gt; Math.sigma(408) 1080 iex&gt; Math.sigma(100000) 246078"},{"ref":"Chunky.Math.html#sigma/2","title":"Chunky.Math.sigma/2","type":"function","doc":"Calculate a sigma function of an integer, for any p-th powers. This is a generalized Sigma function of the form σp(n), so the Sigma-0 of a number σ0(n) would be sigma(n, 0), while the Sigma-4 (σ4(n)) would be sigma(n, 4). For a faster version of σ1(n) (or the sum-of-divisors) see sigma/1. Examples iex&gt; Math.sigma(12, 2) 210 iex&gt; Math.sigma(19, 4) 130322 iex&gt; Math.sigma(24, 0) 8"},{"ref":"Chunky.Math.html#totient/1","title":"Chunky.Math.totient/1","type":"function","doc":"Euler&#39;s totient function for n. Also called phi or written as Φ(n), the Eulerian totient function counts the positive integers up to n that are relatively prime or coprime to n. The method used for calculating this function relies on a partially closed form of Euler&#39;s product formula that grows relative to the number of prime factors of n. Examples iex&gt; Math.totient(36) 12 iex&gt; Math.totient(101) 100 iex&gt; Math.totient(99999) 64800"},{"ref":"Chunky.Sequence.html","title":"Chunky.Sequence","type":"module","doc":"Create and manipulate mathematical sequences. New values in the sequences are created only when requested, allowing iteration of finite and infinite data in a lazy fashion: iex&gt; data = Sequence.create(Sequence.Basic, :whole_numbers) |&gt; Sequence.take(6) iex&gt; data |&gt; Tuple.to_list() |&gt; List.first() [1, 2, 3, 4, 5, 6] Available Sequences The Chunky.Sequence modules have sequences available in: Chunky.Sequence.Basic - Simple integer sequences, and defined sequence progressions Chunky.Sequence.OEIS - Integer Sequences from the Online Encyclopedia of Integer Sequences Chunky.Sequence.Test - Sequences for test purposes About Sequences Sequences are stateful - sequence manipulations will always return a %Sequence{} object along with any other requested data. Repeated calls to the same instance of a Sequence struct will always yield the same result: iex&gt; seq = Sequence.create(Sequence.Basic, :whole_numbers, [start: 100]) iex&gt; (seq |&gt; Sequence.next!()).value 100 iex&gt; (seq |&gt; Sequence.next!()).value 100 The updated Sequence struct needs to be maintained, and passed along to other functions, to create new sequence values: iex&gt; seq_a = Sequence.create(Sequence.Basic, :whole_numbers, [start: 100]) iex&gt; seq_b = seq_a |&gt; Sequence.next!() iex&gt; seq_b.value 100 iex&gt; seq_c = seq_b |&gt; Sequence.next!() iex&gt; seq_c.value 101 or iex&gt; seq_a = Sequence.create(Sequence.Basic, :whole_numbers, [start: 100]) iex&gt; seq_n = seq_a |&gt; Sequence.next!() |&gt; Sequence.next!() |&gt; Sequence.next!() iex&gt; seq_n.value 102 Sequences count indices as they go - the first value will always be at index 0: iex&gt; {_v, seq} = Sequence.create(Sequence.Basic, :whole_numbers) |&gt; Sequence.next() iex&gt; seq.value 1 iex&gt; seq.index 0 Some sequences start at an index other than 0, like the Sum of Odd Divisors (A000593): iex&gt; seq = Sequence.create(Sequence.OEIS.Core, :a000593) |&gt; Sequence.next!() iex&gt; seq.index 1 Working with Sequences Creating Sequences create/3 - Create a new sequence instance Finding and Inspecting Sequences available/0 - List all loaded sequences from all loaded applications and modules available/1 - List available sequences from a specific module has_next?/1 - Check that a sequence has at least one more available value is_available?/2 - Check if a specific sequence is available is_finite?/1 - Check of a sequence is finite or infinite in the Sequence library implementation is_instance?/2 - Check if a sequence is an instance of a specific sequence identifier is_instance?/3 - Check if a sequence is an instance of a specific sequence identifier get_references/1 - Retrieve reference sources and links for a sequence has_reference?/2 - Check if a sequence has a specific reference source readable_name/1 - Find the human readable name of a sequence Manipulating Sequences drop/2 - Drop N values from the front of the sequence map/2 - Apply a function to values in a sequence, and collect the result next/1 - Retrieve the next sequence value and updated sequence struct as a tuple next!/1 - Retrieve the next sequence as just an updated sequence struct take/2 - Like Enum.take/2 - retrieve a list of values from a sequence take!/2 - Like take/2, but only return the updated sequence struct Developing Sequences sequence_for_function/1 - Wrap a function as a sequence - see Developing New Sequences sequence_for_list/1 - Wrap a list as a sequence - see Developing New Sequences Developing New Sequences Sequences can be built in three different ways: Verbose Iterators (See Sequence.Basic.create_sequence_whole_numbers/1) Simple Functions (See sequence_for_function/1 and Sequence.OEIS.create_sequence_a000045/1) Static Lists (See sequence_for_list/1 and Sequence.Basic.create_sequence_empty/1) All three ways of developing sequences have things in common: All will have a create_sequence_*/1 function - this is how the Sequence package finds and instantiates sequences All will have common function attributes (via data @doc attributes) for the create_sequence_*/1 function Sequence Attributes Top level create_sequence_* functions should have the following attributes: sequence - Readable name of the sequence references - List of tuples of the form {:source, :short_name, &quot;URI&quot;} along with the required attributes, the following optional attributes can be used: offset - Integer. Default 0. Start a sequence at an index other than 0. Verbose Iterators The most expressive way to write sequences is using the Verbose Iterators technique. In this style, the create_sequence_*/1 function returns a map that is used to build out the %Sequence{} struct. Let&#39;s take apart the :whole_numbers sequence in the Sequence.Basic module. The create function looks like: @doc sequence: &quot;Whole numbers: [1, 2, 3, 4, 5, ...]&quot;, references: [{:wolfram, :positive_integer, &quot;http://mathworld.wolfram.com/PositiveInteger.html&quot;}, {:wikipedia, :natural_number, &quot;https://en.wikipedia.org/wiki/Natural_number&quot;}] def create_sequence_whole_numbers(opts \\ []) do start = opts |&gt; Keyword.get(:start, 1) %{ next_fn: &amp;seq_whole_number_next/3, data: %{ start: start } } end Starting with the @doc attributes, and working through the whole function: The @doc attribute defines the sequence readable name with the sequence: attribute The @doc attribute defines references for the sequence with the references: attribute (See get_references/1) The function signature create_sequence_whole_numbers/1 defines the sequence identifier whole_numbers - this is automatically translated by the Sequence module functions For this sequence, we check for a start option - what value our sequence should start at We return a Map with two keys, the next_fn which is a function with arity 3, and a data attribute, which we can use to store any data we like Every next_fn (or iterator function) for a sequence can be called in two ways; :init mode and :next mode. The :init mode is used to prime the value and our state, the data attribute we set in our create function. In :next mode we generate the next value in our sequence. Both modes can update the data state map, which is maintained by the sequence functions. This allows more complex information needed to generate values to be stored. Let&#39;s take a look at how the seq_whole_number_next/3 function we referenced handles the two modes for the :whole_numbers sequence: defp seq_whole_number_next(:init, data, _value) do %{ data: data, value: data.start - 1 } end defp seq_whole_number_next(:next, data, value) do { :continue, %{data: data, value: value + 1} } end In this case we use two different functions to handle the :init and :next states. In the :init we update our value, and return our state (the data attribute) as is. When generating the next iteration value in :next mode, we refernce the value parameter, which was the last calculated value for the sequence. In this case we return a slightly different structure: we explicitly let the iterator know that our sequence can continue further - we have more values. The return value of the next_fn iterator can be of three forms. Map form: %{data: %{}, value: _} Continue tuple form: { :continue, %{data: %{}, value: _} } or Last tuple form: { :last, %{data: %{}, value: _} } If the :last tuple form is returned, the sequence is marked as finished, and no further values will be generated. Simple Functions Some sequences can be generated from a single function, like many mathematical progressions. The Verbose Iterator way of writing a sequence would be overkill - we can use the sequence_for_function/1 utility for wrapping a single function in a sequence. See sequence_for_function/1 for more details. As a simple example we can look at how the OEIS Fibonacci sequence is implemented: @doc sequence: &quot;OEIS A000045 - Fibonacci Numbers [0, 1, 1, 2, 3, 5, ...]&quot;, references: [{:oeis, :a000045, &quot;https://oeis.org/A000045&quot;}] def create_sequence_fibonacci(_opts) do sequence_for_function(&amp;seq_a000045/3) end def seq_a000045(idx, a, b) do case idx do 0 -&gt; 0 1 -&gt; 1 _ -&gt; a + b end end Like when writing a sequence as a Verbose Iterator, we have a create_sequence_*/1 function with @doc attributes that define the sequence name and references. Then we provide the sequence_for_function/1 function with a reference to the function that generates values - in this case a fibonacci function that uses the index and last two calculated values to determine the next value in the sequence. Static Lists For sufficiently small finite lists, we can use the sequence_for_list/1 utility function to wrap a list of static values as a sequence. See sequence_for_list/1 for more details. We can take apart the :decimal_digits sequence: @doc sequence: &quot;Decimal digits: [0, 1, 2, 3, 4, ...]&quot;, references: [{:wikipedia, :decimal_digit, &quot;https://en.wikipedia.org/wiki/Numerical_digit&quot;}] def create_sequence_decimal_digits(_opts) do sequence_for_list([0, 1, 2, 3, 4, 5, 6, 7, 8, 9]) end This sequence has the expected sequence: and references: doc attributes, and then a call to the sequence_for_list/1 function with a list of data."},{"ref":"Chunky.Sequence.html#available/0","title":"Chunky.Sequence.available/0","type":"function","doc":"Scan all loaded applications and modules for sequences. This is almost identical to the available/1 function, but it scans a selection of loaded applications and modules, excluding the core libraries, for sequences. The return values are the same as for available/1."},{"ref":"Chunky.Sequence.html#available/1","title":"Chunky.Sequence.available/1","type":"function","doc":"List available sequence in a specific module. Sequences are organized into modules, with sequences of different sources or shapes in different modules. Sequences built or included via alternate packages can also be queried this way. Example iex&gt; Sequence.available(Sequence.Basic) |&gt; length() 3 iex&gt; Sequence.available(Sequence.Basic) |&gt; List.last() %{description: &quot;Whole numbers: [1, 2, 3, 4, 5, ...]&quot;, name: &quot;Whole Numbers&quot;, sequence: :whole_numbers, module: Sequence.Basic}"},{"ref":"Chunky.Sequence.html#create/3","title":"Chunky.Sequence.create/3","type":"function","doc":"Instantiate an instance of a sequence. iex&gt; seq = Sequence.create(Sequence.Basic, :empty) iex&gt; seq |&gt; Sequence.readable_name() &quot;Empty sequence: []&quot; iex&gt; seq = Sequence.create(Sequence.OEIS, :fibonacci) iex&gt; seq |&gt; Sequence.take!(10) [0, 1, 1, 2, 3, 5, 8, 13, 21, 34] Some sequences accept options, which change the progression or shape of the generated sequence data: iex&gt; Sequence.create(Sequence.Basic, :whole_numbers) |&gt; Sequence.take!(5) [1, 2, 3, 4, 5] iex&gt; Sequence.create(Sequence.Basic, :whole_numbers, [start: 13]) |&gt; Sequence.take!(5) [13, 14, 15, 16, 17] Finding Available Sequences Sequences are referenced by Module name and a sequence identifier. The documentation for the Sequence sub-modules contains reference data for all available sequences. See: Chunky.Sequence.Basic Chunky.Sequence.OEIS Available sequences can be found with available/1: iex&gt; Sequence.available(Sequence.Basic) |&gt; List.first() %{description: &quot;Decimal digits: [0, 1, 2, 3, 4, ...]&quot;, name: &quot;Decimal Digits&quot;, sequence: :decimal_digits, module: Sequence.Basic} The function name within a module can also be used to identify a sequence, as all sequence generation functions follow the format create_sequence_*. The OEIS fibonacci sequence is indirectly created via the function Chunky.Sequence.OEIS.create_sequence_fibonacci/1."},{"ref":"Chunky.Sequence.html#drop/2","title":"Chunky.Sequence.drop/2","type":"function","doc":"Drop values from the front of the sequence, returning the updated sequence struct. Like Enum.drop/2. Examples iex&gt; seq = Sequence.create(Sequence.Basic, :whole_numbers) iex&gt; seq |&gt; Sequence.drop(10) |&gt; Sequence.take!(10) [11, 12, 13, 14, 15, 16, 17, 18, 19, 20]"},{"ref":"Chunky.Sequence.html#get_references/1","title":"Chunky.Sequence.get_references/1","type":"function","doc":"Retrieve sequence reference data from a sequence description dictionary, like those returned by available/1 and available/0. Examples iex&gt; %{module: Chunky.Sequence.OEIS.Factors, sequence: :a052486} |&gt; Sequence.get_references() [{:oeis, :a052486, &quot;https://oeis.org/A052486&quot;}, {:wikipedia, :achilles_number, &quot;https://en.wikipedia.org/wiki/Achilles_number&quot;}]"},{"ref":"Chunky.Sequence.html#has_next?/1","title":"Chunky.Sequence.has_next?/1","type":"function","doc":"Check that a sequence has more values. Some sequences are finite, and have distinct end points. For finite sequences it can make sense to check for additional values before trying to access more data: iex&gt; seq = Sequence.create(Sequence.Basic, :empty) |&gt; Sequence.next!() iex&gt; seq |&gt; Sequence.has_next?() false iex&gt; seq = Sequence.create(Sequence.Basic, :whole_numbers) |&gt; Sequence.next!() iex&gt; seq |&gt; Sequence.has_next?() true"},{"ref":"Chunky.Sequence.html#has_reference?/2","title":"Chunky.Sequence.has_reference?/2","type":"function","doc":"Check if a sequence instance has a reference to a specific source. See also get_references/1. Examples iex&gt; Sequence.create(Sequence.Basic, :whole_numbers) |&gt; Sequence.has_reference?(:wolfram) true iex&gt; Sequence.create(Sequence.OEIS, :a000045) |&gt; Sequence.has_reference?(:oeis) true iex&gt; Sequence.create(Sequence.OEIS, :a000045) |&gt; Sequence.has_reference?(:wolfram) false"},{"ref":"Chunky.Sequence.html#is_available?/2","title":"Chunky.Sequence.is_available?/2","type":"function","doc":"Determine if a specific sequence is available. Example iex&gt; Sequence.is_available?(Sequence.OEIS, :fibonacci) true iex&gt; Sequence.is_available?(Sequence.OEIS, :quadronacci) false"},{"ref":"Chunky.Sequence.html#is_finite?/1","title":"Chunky.Sequence.is_finite?/1","type":"function","doc":"Determine if a sequence is finite or infinite. A sequence being finite or infinite is not a reflection of the absolute computability or theoretical limits of a sequence, but is determined by the quantity of values available in the Sequence library implementation. Examples iex&gt; Sequence.create(Sequence.OEIS, :fibonacci) |&gt; Sequence.is_finite?() false iex&gt; Sequence.create(Sequence.OEIS.Core, :a000041) |&gt; Sequence.is_finite?() true"},{"ref":"Chunky.Sequence.html#is_instance?/2","title":"Chunky.Sequence.is_instance?/2","type":"function","doc":"Check if a sequence struct is an instance of a specific sequence. See also is_instance?/3. Example iex&gt; seq = Sequence.create(Sequence.OEIS, :a000045) iex&gt; seq |&gt; Sequence.is_instance?({Sequence.OEIS, :a000066}) false iex&gt; seq |&gt; Sequence.is_instance?({Sequence.OEIS, :a000045}) true"},{"ref":"Chunky.Sequence.html#is_instance?/3","title":"Chunky.Sequence.is_instance?/3","type":"function","doc":"Check if a sequence struct is an instance of a specific sequence. See also is_instance?/2. Example iex&gt; seq = Sequence.create(Sequence.OEIS, :a000045) iex&gt; seq |&gt; Sequence.is_instance?(Sequence.OEIS, :a000066) false iex&gt; seq |&gt; Sequence.is_instance?(Sequence.OEIS, :a000045) true"},{"ref":"Chunky.Sequence.html#map/2","title":"Chunky.Sequence.map/2","type":"function","doc":"Apply a function to every value in a Sequence. Like Enum.map/2. For infinite sequences, this will never complete. Use Sequence.take/2 and apply a normal map. Examples iex&gt; Sequence.create(Sequence.Test, :list_medium) |&gt; Sequence.map(fn v -&gt; v * 3 end) [3, 6, 9, 12, 15, 18, 21, 24, 27, 30]"},{"ref":"Chunky.Sequence.html#next/1","title":"Chunky.Sequence.next/1","type":"function","doc":"Iterate a sequence, returning the sequence value and updated sequence struct. The sequence struct needs to be maintained in order to iterate a sequence; with the next/1 function, you can access the iterated value and the updated struct with the same call. Example iex&gt; seq = Sequence.create(Sequence.Basic, :whole_numbers) iex&gt; {val, _updated_seq} = seq |&gt; Sequence.next() iex&gt; val 1"},{"ref":"Chunky.Sequence.html#next!/1","title":"Chunky.Sequence.next!/1","type":"function","doc":"Iterate a sequence, returning only the updated Sequence structure. The Sequence structure maintains the last index and value seen in a sequence, so is a useful shorthand when explictly returning the sequence value isn&#39;t necessary. This also makes it possible to chain together calls to next!/1 and other sequence methods. Examples iex&gt; seq = Sequence.create(Sequence.Basic, :whole_numbers) iex&gt; updated_seq = seq |&gt; Sequence.next!() iex&gt; updated_seq.value 1"},{"ref":"Chunky.Sequence.html#readable_name/1","title":"Chunky.Sequence.readable_name/1","type":"function","doc":"Get a human readable name for a sequence. Example iex&gt; Sequence.create(Sequence.OEIS, :a000045) |&gt; Sequence.readable_name() &quot;OEIS A000045 - Fibonacci Numbers [0, 1, 1, 2, 3, 5, ...]&quot;"},{"ref":"Chunky.Sequence.html#sequence_for_function/1","title":"Chunky.Sequence.sequence_for_function/1","type":"function","doc":"Create a new sequence from a simple function and an information function. The simple sequence function should take one or more parameters, corresponding to the last N values of the sequence. Configuration Configuration values for the sequence function can be provided as @doc string attributes on the function. Supported attributes are: fill_value - Integer. Optional. Default 0. Filler value used as parameters to sequence function when existing values haven&#39;t yet been calculated sequence - String. Required. Short sequence summary. data - Map. Optional. Static information to add to sequence data attribute Sequence Function The sequence function will be called with the index of the current value to calculate, and the last N values of the function, where N is the function arity minus one. For example, to setup a function that adds the last three values in the sequence, with the first three values being 1, 1, 1, we could write the function: def add_last_three(_idx, a, b, c) do case {a, b, c} do {0, 0, 0} -&gt; 1 {0, 0, _} -&gt; 2 {0, _, _} -&gt; 3 {va, vb, vc} -&gt; va+vb+vc end end In this case we don&#39;t use the index of the function at all. Using the sequence_for_function/1 call we could register this sequence inside a create function (so that it can be properly instantiated): def create_sequence_add_last_three(_opts) do sequence_for_function(&amp;add_last_three/4) end Note that the create_sequence_add_last_three/1 function should have proper sequence and references attributes. See the Developing Sequences section for more details. Attributes For the @doc attributes of the sequence function to readable, the function reference passed to the sequence_for_function/1 function must be scoped to a module or module alias, not a bare referene. This means that this will work: sequence_for_function(&amp;Sequence.Test.seq_last_three/4) but the following will not: sequence_for_function(&amp;seq_last_three/4) Offset Attribute Some sequences don&#39;t start counting at index 0. When a different offset is required than the default 0, the offset attribute can be used. This attribute needs to be set on the create_sequence_* function as well as the simple sequence function: @doc offset: 2 def create_sequence_count_from_two(_opts) do end @doc offset: 2 def seq_count_from_two(idx) do # first _idx_ received will be 2 end Data attribute If the sequence function uses a data attribute, the call signature of the sequence function changes. For example, a simple function using the last two values, with no data attribute, will have a function signature like: def seq_no_data_last_two(idx, a, b) do ... end While a sequence function that has a data attribute will look like: @doc data: %{start_values: [1, 2, 3]} def seq_with_data_last_two(data, idx, a, b) do ... end Fill Value attribute Sequence functions that reference past values are normally called with 0 if some of the past values haven&#39;t yet been created. The fill_value doc attribute can be used to change the default value. For instance, on the first call to iterate the sequence: def seq_defaults_last_two(idx, a, b) do # a == 0 # b == 0 end but when we change the fill_value: @doc fill_value: 17 def seq_fill_last_two(idx, a, b) do # a == 17 # b == 17 end"},{"ref":"Chunky.Sequence.html#sequence_for_list/1","title":"Chunky.Sequence.sequence_for_list/1","type":"function","doc":"Create a sequence that references a static list of data. In the case of suitable small finite sequences, it is significantly easier to use a static list of data as a sequence. The sequence_for_list/1 function provides a simple way to do this. For example, to create a sequence for a short list of 5 numbers: def create_sequence_my_short_list(_opts) do sequence_for_list([3, 7, 11, 27, 47]) end Like with the sequence_for_function/1 example, the above example create_sequence_* function should include full sequence and references doc attributes. See the Developing Sequences section for more details. Sequences generated from a list behave just like any other sequence. Attributes of List Sequences Finite Sequence A sequence created from a list is automatically marked as finite. See is_finite?/1. Offset Attribute Some sequences don&#39;t start counting at index 0. When a different offset is required than the default 0, the offset attribute can be used. This attribute needs to be set on the create_sequence_* function. @doc offset: 2 def create_sequence_count_from_two(_opts) do sequence_from_list([0, 0, 200, 201, 203, 204]) end"},{"ref":"Chunky.Sequence.html#take/2","title":"Chunky.Sequence.take/2","type":"function","doc":"Retrieve the first N values from a sequence, like Enum.take/2. This version of the take function returns a separate list of values and the sequence state. See also Sequence.take!/2. Examples iex&gt; seq = Sequence.create(Sequence.Basic, :whole_numbers) iex&gt; {values, _n_seq} = seq |&gt; Sequence.take(10) iex&gt; values [1, 2, 3, 4, 5, 6, 7, 8, 9, 10] iex&gt; seq = Sequence.create(Sequence.OEIS, :fibonacci) iex&gt; {values, _n_seq} = seq |&gt; Sequence.take(10) iex&gt; values [0, 1, 1, 2, 3, 5, 8, 13, 21, 34]"},{"ref":"Chunky.Sequence.html#take!/2","title":"Chunky.Sequence.take!/2","type":"function","doc":"Retrieve the next count values from a sequence, without retaining sequence state. This function behaves similarly to the take/2 function, but the state of the sequence isn&#39;t maintained, so any subsequent calls to the same sequence will still contain the values retrieved with take!. Examples iex&gt; seq = Sequence.create(Sequence.Basic, :whole_numbers) iex&gt; seq |&gt; Sequence.take!(5) [1, 2, 3, 4, 5] iex&gt; seq |&gt; Sequence.take!(10) [1, 2, 3, 4, 5, 6, 7, 8, 9, 10]"},{"ref":"Chunky.Sequence.Basic.html","title":"Chunky.Sequence.Basic","type":"module","doc":"Working with basic sequences."},{"ref":"Chunky.Sequence.Basic.html#create_sequence_decimal_digits/1","title":"Chunky.Sequence.Basic.create_sequence_decimal_digits/1","type":"function","doc":""},{"ref":"Chunky.Sequence.Basic.html#create_sequence_empty/1","title":"Chunky.Sequence.Basic.create_sequence_empty/1","type":"function","doc":""},{"ref":"Chunky.Sequence.Basic.html#create_sequence_whole_numbers/1","title":"Chunky.Sequence.Basic.create_sequence_whole_numbers/1","type":"function","doc":"Generate the sequence of whole numbers, [1, 2, 3, 4, ...]"},{"ref":"Chunky.Sequence.OEIS.html","title":"Chunky.Sequence.OEIS","type":"module","doc":"Online Encyclopedia of Integer Sequences (OEIS) sequence iterators. Supported sequences are broken down into modules based on OEIS Keyword, subject matter, or related methods. Available Modules Chunky.Sequence.OEIS.Core - OEIS core Keyword sequences Chunky.Sequence.OEIS.Sigma - Sequenecs related to the Sigma (𝝈) function Available Sequences A000045 - Fibonacci Numbers - :a000045 or :fibonacci"},{"ref":"Chunky.Sequence.OEIS.html#coverage/0","title":"Chunky.Sequence.OEIS.coverage/0","type":"function","doc":"Print out a coverage report for named sequence groups (like CORE) in the OEIS sequence support modules."},{"ref":"Chunky.Sequence.OEIS.html#coverage/1","title":"Chunky.Sequence.OEIS.coverage/1","type":"function","doc":"Calculate the OEIS Sequence coverage for a particular sequence group. This is primarily for reference and testing, and is used to determine the completeness of sequence coverage in the Chunky.Sequence.OEIS modules. Example iex&gt; Sequence.create(Sequence.OEIS, :keyword_core) |&gt; Sequence.OEIS.coverage() &lt; 1.0 true iex&gt; Sequence.create(Sequence.OEIS, :keyword_core) |&gt; Sequence.OEIS.coverage() &gt; 0.0 true"},{"ref":"Chunky.Sequence.OEIS.html#create_sequence_a000045/1","title":"Chunky.Sequence.OEIS.create_sequence_a000045/1","type":"function","doc":"OEIS Sequence A000045 - Fibonacci numbers From OEIS A000045 Fibonacci numbers: F(n) = F(n-1) + F(n-2) with F(0) = 0 and F(1) = 1. (Formerly M0692 N0256) Sequence IDs: :a000045, :fibonacci Finite: false Example iex&gt; Sequence.create(Sequence.OEIS, :a000045) |&gt; Sequence.take!(10) [0, 1, 1, 2, 3, 5, 8, 13, 21, 34]"},{"ref":"Chunky.Sequence.OEIS.html#create_sequence_fibonacci/1","title":"Chunky.Sequence.OEIS.create_sequence_fibonacci/1","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.html#create_sequence_keyword_core/1","title":"Chunky.Sequence.OEIS.create_sequence_keyword_core/1","type":"function","doc":"The Online Encyclopedia of Integer Sequences list of Core Sequences. This list is primarily for reference lookup and Sequence introspection, in particular calculating the coverage of Core sequences in Chunky.Sequences."},{"ref":"Chunky.Sequence.OEIS.html#seq_a000045/3","title":"Chunky.Sequence.OEIS.seq_a000045/3","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Core.html","title":"Chunky.Sequence.OEIS.Core","type":"module","doc":"OEIS Core Sequences. Available Sequences A000005 - Divisors of N - :a000005 - create_sequence_a000005/1 A000009 - Number of partitions of n into distinct parts - :a000009 - create_sequence_a000009/1 A000010 - Euler&#39;s totient function - :a000010 - create_sequence_a000010/1 A000041 - Partition Numbers - :a000041 - create_sequence_a000041/1 A000079 - Powers of 2 - :a000079 - create_sequence_a000079/1 A000203 - Sum of Divisors - :a000203 - create_sequence_a000203/1 A000396 - Perfect Numbers - :a000396 - create_sequence_a000396/1 A000593 - Sum of Odd Divisors of N - :a000593 - create_sequence_a000593/1 A001065 - Sum of proper divisors (Aliquot parts) of N. - :a001065 - create_sequence_a001065/1 A001157 - Sum of squares of divisors of N - :a001157 - create_sequence_a001157/1 A005100 - Deficient Numbers - :a005100 - create_sequence_a005100/1 A005101 - Abundant Numbers - :a005101 - create_sequence_a005101/1"},{"ref":"Chunky.Sequence.OEIS.Core.html#create_sequence_a000005/1","title":"Chunky.Sequence.OEIS.Core.create_sequence_a000005/1","type":"function","doc":"OEIS Sequence A000005 - Number of divisors of N, simga-0(n), 𝝈0(n). From OEIS A000005: d(n) (also called tau(n) or sigma_0(n)), the number of divisors of n. (Formerly M0246 N0086) Sequence IDs: :a000005 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Core, :a000005) |&gt; Sequence.take!(10) [1, 2, 2, 3, 2, 4, 2, 4, 3, 4]"},{"ref":"Chunky.Sequence.OEIS.Core.html#create_sequence_a000009/1","title":"Chunky.Sequence.OEIS.Core.create_sequence_a000009/1","type":"function","doc":"OEIS Sequence A000009 - Number of partitions of n into distinct parts From OEIS A000009: Expansion of Product_{m &gt;= 1} (1 + x^m); number of partitions of n into distinct parts; number of partitions of n into odd parts (if n &gt; 0). (Formerly M0281 N0100) Divergence Calculation of this sequence is based on translation of a Maxima program by Vladimir Kruchinin, and diverges from canonical results for n &gt; 10. Sequence IDs: :a000009 Finite: False Offset: 0 Example iex&gt; Sequence.create(Sequence.OEIS.Core, :a000009) |&gt; Sequence.take!(10) [1, 1, 1, 2, 2, 3, 4, 5, 6, 8]"},{"ref":"Chunky.Sequence.OEIS.Core.html#create_sequence_a000010/1","title":"Chunky.Sequence.OEIS.Core.create_sequence_a000010/1","type":"function","doc":"OEIS Sequence A000010 - Euler&#39;s totient function phi(n) From OEIS A000010: Euler totient function phi(n): count numbers &lt;= n and prime to n. (Formerly M0299 N0111) Sequence IDs: :a000010 Finite: false Example iex&gt; Sequence.create(Sequence.OEIS.Core, :a000010) |&gt; Sequence.take!(20) [1, 1, 2, 2, 4, 2, 6, 4, 6, 4, 10, 4, 12, 6, 8, 8, 16, 6, 18, 8]"},{"ref":"Chunky.Sequence.OEIS.Core.html#create_sequence_a000041/1","title":"Chunky.Sequence.OEIS.Core.create_sequence_a000041/1","type":"function","doc":"OEIS Sequence A000041 - Partitions of integer N This sequence contains the partitions of the integers from 0 to 250. From Wikipedia: In number theory, the partition function p(n) represents the number of possible partitions of a non-negative integer n. For instance, p(4) = 5 because the integer 4 has the five partitions: 1 + 1 + 1 + 1, 1 + 1 + 2, 1 + 3, 2 + 2, and 4. From OEIS A000041: a(n) is the number of partitions of n (the partition numbers). (Formerly M0663 N0244) Sequence IDs: :a000041 Finite: true Example iex&gt; Sequence.create(Sequence.OEIS.Core, :a000041) |&gt; Sequence.take!(10) [1, 1, 2, 3, 5, 7, 11, 15, 22, 30]"},{"ref":"Chunky.Sequence.OEIS.Core.html#create_sequence_a000079/1","title":"Chunky.Sequence.OEIS.Core.create_sequence_a000079/1","type":"function","doc":"OEIS Sequence A000079 - Powers of 2 a(n) = 2^n From OEIS A000009: Powers of 2: a(n) = 2^n. (Formerly M1129 N0432) Sequence IDs: :a000079 Finite: False Offset: 0 Example iex&gt; Sequence.create(Sequence.OEIS.Core, :a000079) |&gt; Sequence.take!(20) [1, 2, 4, 8, 16, 32, 64, 128, 256, 512, 1024, 2048, 4096, 8192, 16384, 32768, 65536, 131072, 262144, 524288]"},{"ref":"Chunky.Sequence.OEIS.Core.html#create_sequence_a000203/1","title":"Chunky.Sequence.OEIS.Core.create_sequence_a000203/1","type":"function","doc":"OEIS Sequence A000203 - Sum of Divisors σ1(n) From OEIS A000203: (n) = sigma(n), the sum of the divisors of n. Also called sigma_1(n). (Formerly M2329 N0921) Sequence IDs: :a000203 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Core, :a000203) |&gt; Sequence.take!(20) [1, 3, 4, 7, 6, 12, 8, 15, 13, 18, 12, 28, 14, 24, 24, 31, 18, 39, 20, 42]"},{"ref":"Chunky.Sequence.OEIS.Core.html#create_sequence_a000396/1","title":"Chunky.Sequence.OEIS.Core.create_sequence_a000396/1","type":"function","doc":"OEIS Sequence A000396 - Perfect Numbers From OEIS A000396: Perfect numbers n: n is equal to the sum of the proper divisors of n. (Formerly M4186 N1744) Sequence IDs: :a000396 Finite: True Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Core, :a000396) |&gt; Sequence.take!(5) [6, 28, 496, 8128, 33550336]"},{"ref":"Chunky.Sequence.OEIS.Core.html#create_sequence_a000593/1","title":"Chunky.Sequence.OEIS.Core.create_sequence_a000593/1","type":"function","doc":"OEIS Sequence A000593 - Sum of Odd Divisors of N From OEIS A000593: Sum of odd divisors of n. (Formerly M3197 N1292) Sequence IDs: :a000593 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Core, :a000593) |&gt; Sequence.take!(10) [1, 1, 4, 1, 6, 4, 8, 1, 13, 6]"},{"ref":"Chunky.Sequence.OEIS.Core.html#create_sequence_a001065/1","title":"Chunky.Sequence.OEIS.Core.create_sequence_a001065/1","type":"function","doc":"OEIS Sequence A001065 - Sum of proper divisors (Aliquot parts) of N. From OEIS A001065: Sum of proper divisors (or aliquot parts) of n: sum of divisors of n that are less than n. (Formerly M2226 N0884) Sequence IDs: :a001065 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Core, :a001065) |&gt; Sequence.take!(20) [0, 1, 1, 3, 1, 6, 1, 7, 4, 8, 1, 16, 1, 10, 9, 15, 1, 21, 1, 22]"},{"ref":"Chunky.Sequence.OEIS.Core.html#create_sequence_a001157/1","title":"Chunky.Sequence.OEIS.Core.create_sequence_a001157/1","type":"function","doc":"OEIS Sequence A001157 - Sum of squares of divisors of N, simga-2(n), 𝝈2(n). From OEIS A001157: sigma_2(n): sum of squares of divisors of n. (Formerly M3799 N1551) Sequence IDs: :a001157 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Core, :a001157) |&gt; Sequence.take!(10) [1, 5, 10, 21, 26, 50, 50, 85, 91, 130]"},{"ref":"Chunky.Sequence.OEIS.Core.html#create_sequence_a005100/1","title":"Chunky.Sequence.OEIS.Core.create_sequence_a005100/1","type":"function","doc":"OEIS Sequence A005100 - Deficient Numbers From OEIS A005100: Deficient numbers: numbers n such that sigma(n) &lt; 2n. (Formerly M0514) Sequence IDs: :a005100 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Core, :a005100) |&gt; Sequence.take!(25) [1, 2, 3, 4, 5, 7, 8, 9, 10, 11, 13, 14, 15, 16, 17, 19, 21, 22, 23, 25, 26, 27, 29, 31, 32]"},{"ref":"Chunky.Sequence.OEIS.Core.html#create_sequence_a005101/1","title":"Chunky.Sequence.OEIS.Core.create_sequence_a005101/1","type":"function","doc":"OEIS Sequence A005101 - Abundant Numbers From OEIS A005101: Abundant numbers (sum of divisors of n exceeds 2n). (Formerly M4825) Sequence IDs: :a005101 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Core, :a005101) |&gt; Sequence.take!(10) [12, 18, 20, 24, 30, 36, 40, 42, 48, 54]"},{"ref":"Chunky.Sequence.OEIS.Core.html#seq_a000005/1","title":"Chunky.Sequence.OEIS.Core.seq_a000005/1","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Core.html#seq_a000009/1","title":"Chunky.Sequence.OEIS.Core.seq_a000009/1","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Core.html#seq_a000010/1","title":"Chunky.Sequence.OEIS.Core.seq_a000010/1","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Core.html#seq_a000079/1","title":"Chunky.Sequence.OEIS.Core.seq_a000079/1","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Core.html#seq_a000203/1","title":"Chunky.Sequence.OEIS.Core.seq_a000203/1","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Core.html#seq_a000593/1","title":"Chunky.Sequence.OEIS.Core.seq_a000593/1","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Core.html#seq_a001065/1","title":"Chunky.Sequence.OEIS.Core.seq_a001065/1","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Core.html#seq_a001157/1","title":"Chunky.Sequence.OEIS.Core.seq_a001157/1","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Core.html#seq_a005100/2","title":"Chunky.Sequence.OEIS.Core.seq_a005100/2","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Core.html#seq_a005101/2","title":"Chunky.Sequence.OEIS.Core.seq_a005101/2","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Factors.html","title":"Chunky.Sequence.OEIS.Factors","type":"module","doc":"OEIS Sequences dealing with Factors, Factorization, and properties of integer factors. Available Sequences A001597 - Perfect Powers - :a001597 - create_sequence_a001597/1 A001694 - Powerful Numbers - :a001694 - create_sequence_a001694/1 A002182 - Highly composite numbers: numbers with record value - :a002182 - create_sequence_a002182/1 A002473 - 7-smooth Numbers - :a002473 - create_sequence_a03586/1 A003586 - 3-smooth Numbers - :a003586 - create_sequence_a03586/1 A005361 - Product of Expoenents of prime factors of N - :a005361 - create_sequence_a005361/1 A005934 - Highly powerful numbers: numbers with record value - :a005934 - create_sequence_a005934/1 A051037 - 5-smooth Numbers - :a051037 - create_sequence_a03586/1 A051038 - 11-smooth Numbers - :a051038 - create_sequence_a03586/1 A052486 - Achilles numbers - powerful but imperfect - :a052486 - create_sequence_a052486/1 A080197 - 13-smooth Numbers - :a080197 - create_sequence_a03586/1 A080681 - 17-smooth Numbers - :a080681 - create_sequence_a03586/1 A080682 - 29-smooth Numbers - :a080682 - create_sequence_a03586/1 A080683 - 23-smooth Numbers - :a080683 - create_sequence_a03586/1"},{"ref":"Chunky.Sequence.OEIS.Factors.html#create_sequence_a001597/1","title":"Chunky.Sequence.OEIS.Factors.create_sequence_a001597/1","type":"function","doc":"OEIS Sequence A001597 - Perfect Powers From OEIS A001597: Perfect powers: m^k where m &gt; 0 and k &gt;= 2. (Formerly M3326 N1336) Sequence IDs: :a001597 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Factors, :a001597) |&gt; Sequence.take!(20) [1, 4, 8, 9, 16, 25, 27, 32, 36, 49, 64, 81, 100, 121, 125, 128, 144, 169, 196, 216]"},{"ref":"Chunky.Sequence.OEIS.Factors.html#create_sequence_a001694/1","title":"Chunky.Sequence.OEIS.Factors.create_sequence_a001694/1","type":"function","doc":"OEIS Sequence A001694 - Powerful Numbers From OEIS A001694: Powerful numbers, definition (1): if a prime p divides n then p^2 must also divide n (also called squareful, square full, square-full or 2-powerful numbers). (Formerly M3325 N1335) Sequence IDs: :a001694 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Factors, :a001694) |&gt; Sequence.take!(20) [1, 4, 8, 9, 16, 25, 27, 32, 36, 49, 64, 72, 81, 100, 108, 121, 125, 128, 144, 169]"},{"ref":"Chunky.Sequence.OEIS.Factors.html#create_sequence_a002182/1","title":"Chunky.Sequence.OEIS.Factors.create_sequence_a002182/1","type":"function","doc":"OEIS Sequence A002182 - Highly composite numbers: numbers with record value From OEIS A002182: Highly composite numbers, definition (1): where d(n), the number of divisors of n (A000005), increases to a record. (Formerly M1025 N0385) Sequence IDs: :a002182 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Factors, :a002182) |&gt; Sequence.take!(20) [1, 2, 4, 6, 12, 24, 36, 48, 60, 120, 180, 240, 360, 720, 840, 1260, 1680, 2520, 5040, 7560]"},{"ref":"Chunky.Sequence.OEIS.Factors.html#create_sequence_a002473/1","title":"Chunky.Sequence.OEIS.Factors.create_sequence_a002473/1","type":"function","doc":"OEIS Sequence A002473 - 7-smooth Numbers From OEIS A002473: 7-smooth numbers: positive numbers whose prime divisors are all &lt;= 7. (Formerly M0477 N0177) Sequence IDs: :a002473 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Factors, :a002473) |&gt; Sequence.drop(20) |&gt; Sequence.take!(20) [28, 30, 32, 35, 36, 40, 42, 45, 48, 49, 50, 54, 56, 60, 63, 64, 70, 72, 75, 80]"},{"ref":"Chunky.Sequence.OEIS.Factors.html#create_sequence_a003586/1","title":"Chunky.Sequence.OEIS.Factors.create_sequence_a003586/1","type":"function","doc":"OEIS Sequence A003586 - 3-smooth Numbers From OEIS A003586: 3-smooth numbers: numbers of the form 2^i*3^j with i, j &gt;= 0. Sequence IDs: :a003586 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Factors, :a003586) |&gt; Sequence.drop(20) |&gt; Sequence.take!(20) [108, 128, 144, 162, 192, 216, 243, 256, 288, 324, 384, 432, 486, 512, 576, 648, 729, 768, 864, 972]"},{"ref":"Chunky.Sequence.OEIS.Factors.html#create_sequence_a005361/1","title":"Chunky.Sequence.OEIS.Factors.create_sequence_a005361/1","type":"function","doc":"OEIS Sequence A005361 - Product of Expoenents of prime factors of N From OEIS A005361: Product of exponents of prime factorization of n. (Formerly M0063) Sequence IDs: :a005361 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Factors, :a005361) |&gt; Sequence.take!(20) [1, 1, 1, 2, 1, 1, 1, 3, 2, 1, 1, 2, 1, 1, 1, 4, 1, 2, 1, 2]"},{"ref":"Chunky.Sequence.OEIS.Factors.html#create_sequence_a005934/1","title":"Chunky.Sequence.OEIS.Factors.create_sequence_a005934/1","type":"function","doc":"OEIS Sequence A005934 - Highly powerful numbers: numbers with record value From OEIS A005934: Highly powerful numbers: numbers with record value of the product of the exponents in prime factorization (A005361). (Formerly M3333) Sequence IDs: :a005934 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Factors, :a005934) |&gt; Sequence.take!(20) [1, 4, 8, 16, 32, 64, 128, 144, 216, 288, 432, 864, 1296, 1728, 2592, 3456, 5184, 7776, 10368, 15552]"},{"ref":"Chunky.Sequence.OEIS.Factors.html#create_sequence_a051037/1","title":"Chunky.Sequence.OEIS.Factors.create_sequence_a051037/1","type":"function","doc":"OEIS Sequence A051037 - 5-smooth Numbers From OEIS A051037: 5-smooth numbers, i.e., numbers whose prime divisors are all &lt;= 5 Sequence IDs: :a051037 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Factors, :a051037) |&gt; Sequence.drop(20) |&gt; Sequence.take!(20) [40, 45, 48, 50, 54, 60, 64, 72, 75, 80, 81, 90, 96, 100, 108, 120, 125, 128, 135, 144]"},{"ref":"Chunky.Sequence.OEIS.Factors.html#create_sequence_a051038/1","title":"Chunky.Sequence.OEIS.Factors.create_sequence_a051038/1","type":"function","doc":"OEIS Sequence A051038 - 11-smooth Numbers From OEIS A051038: 11-smooth numbers: numbers whose prime divisors are all &lt;= 11. Sequence IDs: :a051038 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Factors, :a051038) |&gt; Sequence.drop(20) |&gt; Sequence.take!(20) [25, 27, 28, 30, 32, 33, 35, 36, 40, 42, 44, 45, 48, 49, 50, 54, 55, 56, 60, 63]"},{"ref":"Chunky.Sequence.OEIS.Factors.html#create_sequence_a052486/1","title":"Chunky.Sequence.OEIS.Factors.create_sequence_a052486/1","type":"function","doc":"OEIS Sequence A052486 - Achilles numbers - powerful but imperfect From OEIS A052486: Achilles numbers - powerful but imperfect: if n = Product(p_i^e_i) then all e_i &gt; 1 (i.e., powerful), but the highest common factor of the e_i is 1, i.e., not a perfect power. Sequence IDs: :a052486 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Factors, :a052486) |&gt; Sequence.take!(20) [72, 108, 200, 288, 392, 432, 500, 648, 675, 800, 864, 968, 972, 1125, 1152, 1323, 1352, 1372, 1568, 1800]"},{"ref":"Chunky.Sequence.OEIS.Factors.html#create_sequence_a080197/1","title":"Chunky.Sequence.OEIS.Factors.create_sequence_a080197/1","type":"function","doc":"OEIS Sequence A080197 - 13-smooth Numbers From OEIS A080197: 13-smooth numbers: numbers whose prime divisors are all &lt;= 13. Sequence IDs: :a080197 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Factors, :a080197) |&gt; Sequence.drop(20) |&gt; Sequence.take!(20) [24, 25, 26, 27, 28, 30, 32, 33, 35, 36, 39, 40, 42, 44, 45, 48, 49, 50, 52, 54]"},{"ref":"Chunky.Sequence.OEIS.Factors.html#create_sequence_a080681/1","title":"Chunky.Sequence.OEIS.Factors.create_sequence_a080681/1","type":"function","doc":"OEIS Sequence A080681 - 17-smooth Numbers From OEIS A080681: 17-smooth numbers: numbers whose prime divisors are all &lt;= 17. Sequence IDs: :a080681 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Factors, :a080681) |&gt; Sequence.drop(20) |&gt; Sequence.take!(20) [22, 24, 25, 26, 27, 28, 30, 32, 33, 34, 35, 36, 39, 40, 42, 44, 45, 48, 49, 50]"},{"ref":"Chunky.Sequence.OEIS.Factors.html#create_sequence_a080682/1","title":"Chunky.Sequence.OEIS.Factors.create_sequence_a080682/1","type":"function","doc":"OEIS Sequence A080682 - 19-smooth Numbers From OEIS A080682: 19-smooth numbers: numbers whose prime divisors are all &lt;= 19. Sequence IDs: :a080682 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Factors, :a080682) |&gt; Sequence.drop(20) |&gt; Sequence.take!(20) [21, 22, 24, 25, 26, 27, 28, 30, 32, 33, 34, 35, 36, 38, 39, 40, 42, 44, 45, 48]"},{"ref":"Chunky.Sequence.OEIS.Factors.html#create_sequence_a080683/1","title":"Chunky.Sequence.OEIS.Factors.create_sequence_a080683/1","type":"function","doc":"OEIS Sequence A080683 - 23-smooth Numbers From OEIS A080683: 23-smooth numbers: numbers whose prime divisors are all &lt;= 23. Sequence IDs: :a080683 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Factors, :a080683) |&gt; Sequence.drop(20) |&gt; Sequence.take!(20) [21, 22, 23, 24, 25, 26, 27, 28, 30, 32, 33, 34, 35, 36, 38, 39, 40, 42, 44, 45]"},{"ref":"Chunky.Sequence.OEIS.Factors.html#seq_a001597/2","title":"Chunky.Sequence.OEIS.Factors.seq_a001597/2","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Factors.html#seq_a001694/2","title":"Chunky.Sequence.OEIS.Factors.seq_a001694/2","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Factors.html#seq_a002473/2","title":"Chunky.Sequence.OEIS.Factors.seq_a002473/2","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Factors.html#seq_a003586/2","title":"Chunky.Sequence.OEIS.Factors.seq_a003586/2","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Factors.html#seq_a005361/1","title":"Chunky.Sequence.OEIS.Factors.seq_a005361/1","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Factors.html#seq_a051037/2","title":"Chunky.Sequence.OEIS.Factors.seq_a051037/2","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Factors.html#seq_a051038/2","title":"Chunky.Sequence.OEIS.Factors.seq_a051038/2","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Factors.html#seq_a052486/2","title":"Chunky.Sequence.OEIS.Factors.seq_a052486/2","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Factors.html#seq_a080197/2","title":"Chunky.Sequence.OEIS.Factors.seq_a080197/2","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Factors.html#seq_a080681/2","title":"Chunky.Sequence.OEIS.Factors.seq_a080681/2","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Factors.html#seq_a080682/2","title":"Chunky.Sequence.OEIS.Factors.seq_a080682/2","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Factors.html#seq_a080683/2","title":"Chunky.Sequence.OEIS.Factors.seq_a080683/2","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Sigma.html","title":"Chunky.Sequence.OEIS.Sigma","type":"module","doc":"OEIS Sequences for Sigma values. Some sigma sequences are in the Sequence.OEIS.Core module. Available Sequences A001158 - Sum of cubes of divisors of N, simga-3(n) - :a001158 - create_sequence_a001158/1 A001159 - sum of 4th powers of divisors of n, simga-4(n) - a001159 - create_sequence_a001159/1 A001160 - sum of 5th powers of divisors of n, simga-5(n) - a001160 - create_sequence_a001160/1 A002093 - Highly Abundant Numbers - a002093 - create_sequence_a002093/1 A003601 - Arithmetic Numbers - a003601 - create_sequence_a003601/1 A013954 - sum of 6th powers of divisors of n, simga-6(n) - a013954 - create_sequence_a013954/1 A013955 - sum of 7th powers of divisors of n, simga-7(n) - a013955 - create_sequence_a013955/1 A013956 - sum of 8th powers of divisors of n, simga-8(n) - a013956 - create_sequence_a013956/1 A013957 - sum of 9th powers of divisors of n, simga-9(n) - a013957 - create_sequence_a013957/1 A013958 - sum of 10th powers of divisors of n, simga-10(n) - a013958 - create_sequence_a013958/1 A013959 - sum of 11th powers of divisors of n, simga-11(n) - a013959 - create_sequence_a013959/1 A013960 - sum of 12th powers of divisors of n, simga-12(n) - a013960 - create_sequence_a013960/1 A013961 - sum of 13th powers of divisors of n, simga-13(n) - a013961 - create_sequence_a013961/1 A013962 - sum of 14th powers of divisors of n, simga-14(n) - a013962 - create_sequence_a013962/1 A013963 - sum of 15th powers of divisors of n, simga-15(n) - a013963 - create_sequence_a013963/1 A013964 - sum of 16th powers of divisors of n, simga-16(n) - a013964 - create_sequence_a013964/1 A013965 - sum of 17th powers of divisors of n, simga-17(n) - a013965 - create_sequence_a013965/1 A013966 - sum of 18th powers of divisors of n, simga-18(n) - a013966 - create_sequence_a013966/1 A013967 - sum of 19th powers of divisors of n, simga-19(n) - a013967 - create_sequence_a013967/1 A013968 - sum of 20th powers of divisors of n, simga-20(n) - a013968 - create_sequence_a013968/1"},{"ref":"Chunky.Sequence.OEIS.Sigma.html#create_sequence_a001158/1","title":"Chunky.Sequence.OEIS.Sigma.create_sequence_a001158/1","type":"function","doc":"OEIS Sequence A001158 - Sum of cubes of divisors of N, simga-3(n), 𝝈3(n). From OEIS A001158: sigma_3(n): sum of cubes of divisors of n. (Formerly M4605 N1964) Sequence IDs: :a001158 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Sigma, :a001158) |&gt; Sequence.take!(10) [1, 9, 28, 73, 126, 252, 344, 585, 757, 1134]"},{"ref":"Chunky.Sequence.OEIS.Sigma.html#create_sequence_a001159/1","title":"Chunky.Sequence.OEIS.Sigma.create_sequence_a001159/1","type":"function","doc":"OEIS Sequence A001159 - sum of 4th powers of divisors of n, simga-4(n), 𝝈4(n). From OEIS A001159: sigma_4(n): sum of 4th powers of divisors of n. (Formerly M5041 N2177) Sequence IDs: :a001159 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Sigma, :a001159) |&gt; Sequence.take!(10) [1, 17, 82, 273, 626, 1394, 2402, 4369, 6643, 10642]"},{"ref":"Chunky.Sequence.OEIS.Sigma.html#create_sequence_a001160/1","title":"Chunky.Sequence.OEIS.Sigma.create_sequence_a001160/1","type":"function","doc":"OEIS Sequence A001160 - sum of 5th powers of divisors of n, simga-5(n), 𝝈5(n). From OEIS A001160: sigma_5(n): sum of 5th powers of divisors of n. (Formerly M5240 N2279) Sequence IDs: :a001160 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Sigma, :a001160) |&gt; Sequence.take!(10) [1, 33, 244, 1057, 3126, 8052, 16808, 33825, 59293, 103158]"},{"ref":"Chunky.Sequence.OEIS.Sigma.html#create_sequence_a002093/1","title":"Chunky.Sequence.OEIS.Sigma.create_sequence_a002093/1","type":"function","doc":"OEIS Sequence A002093 - Highly Abundant Numbers From OEIS A002093: Highly abundant numbers: numbers n such that sigma(n) &gt; sigma(m) for all m &lt; n. (Formerly M0553 N0200) Sequence IDs: :a002093 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Sigma, :a002093) |&gt; Sequence.take!(25) [1, 2, 3, 4, 6, 8, 10, 12, 16, 18, 20, 24, 30, 36, 42, 48, 60, 72, 84, 90, 96, 108, 120, 144, 168]"},{"ref":"Chunky.Sequence.OEIS.Sigma.html#create_sequence_a003601/1","title":"Chunky.Sequence.OEIS.Sigma.create_sequence_a003601/1","type":"function","doc":"OEIS Sequence A003601 - Arithmetic Numbers From OEIS A003601: Numbers n such that the average of the divisors of n is an integer: sigma_0(n) divides sigma_1(n). Alternatively, tau(n) (A000005(n)) divides sigma(n) (A000203(n)). (Formerly M2389) Sequence IDs: :a003601 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Sigma, :a003601) |&gt; Sequence.take!(10) [1, 3, 5, 6, 7, 11, 13, 14, 15, 17]"},{"ref":"Chunky.Sequence.OEIS.Sigma.html#create_sequence_a013954/1","title":"Chunky.Sequence.OEIS.Sigma.create_sequence_a013954/1","type":"function","doc":"OEIS Sequence A013954 - sum of 6th powers of divisors of n, simga-6(n), 𝝈6(n). From OEIS A013954: sigma_6(n): sum of 6th powers of divisors of n. Sequence IDs: :a013954 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Sigma, :a013954) |&gt; Sequence.take!(10) [1, 65, 730, 4161, 15626, 47450, 117650, 266305, 532171, 1015690]"},{"ref":"Chunky.Sequence.OEIS.Sigma.html#create_sequence_a013955/1","title":"Chunky.Sequence.OEIS.Sigma.create_sequence_a013955/1","type":"function","doc":"OEIS Sequence A013955 - sum of 7th powers of divisors of n, simga-7(n), 𝝈7(n). From OEIS A013955: sigma_7(n): sum of 7th powers of divisors of n. Sequence IDs: :a013955 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Sigma, :a013955) |&gt; Sequence.take!(10) [1, 129, 2188, 16513, 78126, 282252, 823544, 2113665, 4785157, 10078254]"},{"ref":"Chunky.Sequence.OEIS.Sigma.html#create_sequence_a013956/1","title":"Chunky.Sequence.OEIS.Sigma.create_sequence_a013956/1","type":"function","doc":"OEIS Sequence A013956 - sum of 8th powers of divisors of n, simga-8(n), 𝝈8(n). From OEIS A013956: sigma_8(n): sum of 8th powers of divisors of n. Sequence IDs: :a013956 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Sigma, :a013956) |&gt; Sequence.take!(10) [1, 257, 6562, 65793, 390626, 1686434, 5764802, 16843009, 43053283, 100390882]"},{"ref":"Chunky.Sequence.OEIS.Sigma.html#create_sequence_a013957/1","title":"Chunky.Sequence.OEIS.Sigma.create_sequence_a013957/1","type":"function","doc":"OEIS Sequence A013957 - sum of 9th powers of divisors of n, simga-9(n), 𝝈9(n). From OEIS A013957: sigma_9(n): sum of 9th powers of divisors of n. Sequence IDs: :a013957 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Sigma, :a013957) |&gt; Sequence.take!(10) [1, 513, 19684, 262657, 1953126, 10097892, 40353608, 134480385, 387440173, 1001953638]"},{"ref":"Chunky.Sequence.OEIS.Sigma.html#create_sequence_a013958/1","title":"Chunky.Sequence.OEIS.Sigma.create_sequence_a013958/1","type":"function","doc":"OEIS Sequence A013958 - sum of 10th powers of divisors of n, simga-10(n), 𝝈10(n). From OEIS A013958: sigma_10(n): sum of 10th powers of divisors of n. Sequence IDs: :a013958 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Sigma, :a013958) |&gt; Sequence.take!(10) [1, 1025, 59050, 1049601, 9765626, 60526250, 282475250, 1074791425, 3486843451, 10009766650]"},{"ref":"Chunky.Sequence.OEIS.Sigma.html#create_sequence_a013959/1","title":"Chunky.Sequence.OEIS.Sigma.create_sequence_a013959/1","type":"function","doc":"OEIS Sequence A013959 - sum of 11th powers of divisors of n, simga-11(n), 𝝈11(n). From OEIS A013959: sigma_11(n): sum of 11th powers of divisors of n. Sequence IDs: :a013959 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Sigma, :a013959) |&gt; Sequence.take!(10) [1, 2049, 177148, 4196353, 48828126, 362976252, 1977326744, 8594130945, 31381236757, 100048830174]"},{"ref":"Chunky.Sequence.OEIS.Sigma.html#create_sequence_a013960/1","title":"Chunky.Sequence.OEIS.Sigma.create_sequence_a013960/1","type":"function","doc":"OEIS Sequence A013960 - sum of 12th powers of divisors of n, simga-12(n), 𝝈12(n). From OEIS A013960: sigma_12(n): sum of 12th powers of divisors of n. Sequence IDs: :a013960 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Sigma, :a013960) |&gt; Sequence.take!(10) [1, 4097, 531442, 16781313, 244140626, 2177317874, 13841287202, 68736258049, 282430067923, 1000244144722]"},{"ref":"Chunky.Sequence.OEIS.Sigma.html#create_sequence_a013961/1","title":"Chunky.Sequence.OEIS.Sigma.create_sequence_a013961/1","type":"function","doc":"OEIS Sequence A013961 - sum of 13th powers of divisors of n, simga-13(n), 𝝈13(n). From OEIS A013961: sigma_13(n): sum of 13th powers of divisors of n. Sequence IDs: :a013961 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Sigma, :a013961) |&gt; Sequence.take!(10) [1, 8193, 1594324, 67117057, 1220703126, 13062296532, 96889010408, 549822930945, 2541867422653, 10001220711318]"},{"ref":"Chunky.Sequence.OEIS.Sigma.html#create_sequence_a013962/1","title":"Chunky.Sequence.OEIS.Sigma.create_sequence_a013962/1","type":"function","doc":"OEIS Sequence A013962 - sum of 14th powers of divisors of n, simga-14(n), 𝝈14(n). From OEIS A013962: sigma_14(n): sum of 14th powers of divisors of n. Sequence IDs: :a013962 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Sigma, :a013962) |&gt; Sequence.take!(10) [1, 16385, 4782970, 268451841, 6103515626, 78368963450, 678223072850, 4398314962945, 22876797237931, 100006103532010]"},{"ref":"Chunky.Sequence.OEIS.Sigma.html#create_sequence_a013963/1","title":"Chunky.Sequence.OEIS.Sigma.create_sequence_a013963/1","type":"function","doc":"OEIS Sequence A013963 - sum of 15th powers of divisors of n, simga-15(n), 𝝈15(n). From OEIS A013963: sigma_15(n): sum of 15th powers of divisors of n. Sequence IDs: :a013963 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Sigma, :a013963) |&gt; Sequence.take!(10) [1, 32769, 14348908, 1073774593, 30517578126, 470199366252, 4747561509944, 35185445863425, 205891146443557, 1000030517610894]"},{"ref":"Chunky.Sequence.OEIS.Sigma.html#create_sequence_a013964/1","title":"Chunky.Sequence.OEIS.Sigma.create_sequence_a013964/1","type":"function","doc":"OEIS Sequence A013964 - sum of 16th powers of divisors of n, simga-16(n), 𝝈16(n). From OEIS A013964: sigma_16(n): sum of 16th powers of divisors of n. Sequence IDs: :a013964 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Sigma, :a013964) |&gt; Sequence.take!(10) [1, 65537, 43046722, 4295032833, 152587890626, 2821153019714, 33232930569602, 281479271743489, 1853020231898563, 10000152587956162]"},{"ref":"Chunky.Sequence.OEIS.Sigma.html#create_sequence_a013965/1","title":"Chunky.Sequence.OEIS.Sigma.create_sequence_a013965/1","type":"function","doc":"OEIS Sequence A013965 - sum of 17th powers of divisors of n, simga-17(n), 𝝈17(n). From OEIS A013965: sigma_17(n): sum of 17th powers of divisors of n. Sequence IDs: :a013965 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Sigma, :a013965) |&gt; Sequence.take!(10) [1, 131073, 129140164, 17180000257, 762939453126, 16926788715972, 232630513987208, 2251816993685505, 16677181828806733, 100000762939584198]"},{"ref":"Chunky.Sequence.OEIS.Sigma.html#create_sequence_a013966/1","title":"Chunky.Sequence.OEIS.Sigma.create_sequence_a013966/1","type":"function","doc":"OEIS Sequence A013966 - sum of 18th powers of divisors of n, simga-18(n), 𝝈18(n). From OEIS A013966: sigma_18(n): sum of 18th powers of divisors of n. Sequence IDs: :a013966 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Sigma, :a013966) |&gt; Sequence.take!(10) [1, 262145, 387420490, 68719738881, 3814697265626, 101560344351050, 1628413597910450, 18014467229220865, 150094635684419611, 1000003814697527770]"},{"ref":"Chunky.Sequence.OEIS.Sigma.html#create_sequence_a013967/1","title":"Chunky.Sequence.OEIS.Sigma.create_sequence_a013967/1","type":"function","doc":"OEIS Sequence A013967 - sum of 19th powers of divisors of n, simga-19(n), 𝝈19(n). From OEIS A013967: sigma_19(n): sum of 19th powers of divisors of n. Sequence IDs: :a013967 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Sigma, :a013967) |&gt; Sequence.take!(10) [1, 524289, 1162261468, 274878431233, 19073486328126, 609360902796252, 11398895185373144, 144115462954287105, 1350851718835253557, 10000019073486852414]"},{"ref":"Chunky.Sequence.OEIS.Sigma.html#create_sequence_a013968/1","title":"Chunky.Sequence.OEIS.Sigma.create_sequence_a013968/1","type":"function","doc":"OEIS Sequence A013968 - sum of 20th powers of divisors of n, simga-20(n), 𝝈20(n). From OEIS A013968: sigma_20(n): sum of 20th powers of divisors of n. Sequence IDs: :a013968 Finite: False Offset: 1 Example iex&gt; Sequence.create(Sequence.OEIS.Sigma, :a013968) |&gt; Sequence.take!(10) [1, 1048577, 3486784402, 1099512676353, 95367431640626, 3656161927895954, 79792266297612002, 1152922604119523329, 12157665462543713203, 100000095367432689202]"},{"ref":"Chunky.Sequence.OEIS.Sigma.html#seq_a001158/1","title":"Chunky.Sequence.OEIS.Sigma.seq_a001158/1","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Sigma.html#seq_a001159/1","title":"Chunky.Sequence.OEIS.Sigma.seq_a001159/1","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Sigma.html#seq_a001160/1","title":"Chunky.Sequence.OEIS.Sigma.seq_a001160/1","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Sigma.html#seq_a002093/3","title":"Chunky.Sequence.OEIS.Sigma.seq_a002093/3","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Sigma.html#seq_a003601/2","title":"Chunky.Sequence.OEIS.Sigma.seq_a003601/2","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Sigma.html#seq_a013954/1","title":"Chunky.Sequence.OEIS.Sigma.seq_a013954/1","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Sigma.html#seq_a013955/1","title":"Chunky.Sequence.OEIS.Sigma.seq_a013955/1","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Sigma.html#seq_a013956/1","title":"Chunky.Sequence.OEIS.Sigma.seq_a013956/1","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Sigma.html#seq_a013957/1","title":"Chunky.Sequence.OEIS.Sigma.seq_a013957/1","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Sigma.html#seq_a013958/1","title":"Chunky.Sequence.OEIS.Sigma.seq_a013958/1","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Sigma.html#seq_a013959/1","title":"Chunky.Sequence.OEIS.Sigma.seq_a013959/1","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Sigma.html#seq_a013960/1","title":"Chunky.Sequence.OEIS.Sigma.seq_a013960/1","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Sigma.html#seq_a013961/1","title":"Chunky.Sequence.OEIS.Sigma.seq_a013961/1","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Sigma.html#seq_a013962/1","title":"Chunky.Sequence.OEIS.Sigma.seq_a013962/1","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Sigma.html#seq_a013963/1","title":"Chunky.Sequence.OEIS.Sigma.seq_a013963/1","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Sigma.html#seq_a013964/1","title":"Chunky.Sequence.OEIS.Sigma.seq_a013964/1","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Sigma.html#seq_a013965/1","title":"Chunky.Sequence.OEIS.Sigma.seq_a013965/1","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Sigma.html#seq_a013966/1","title":"Chunky.Sequence.OEIS.Sigma.seq_a013966/1","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Sigma.html#seq_a013967/1","title":"Chunky.Sequence.OEIS.Sigma.seq_a013967/1","type":"function","doc":""},{"ref":"Chunky.Sequence.OEIS.Sigma.html#seq_a013968/1","title":"Chunky.Sequence.OEIS.Sigma.seq_a013968/1","type":"function","doc":""},{"ref":"Chunky.Sequence.Test.html","title":"Chunky.Sequence.Test","type":"module","doc":"Test sequences with variations on sequence constructions. Test Conditions Verbose Iterators :whole_numbers - infinite iterator Simple Functions :doubler - infinite iterator, double index :last_two - add last two values, :last_three - add last three values, prep with specific fill value attribute :cycle - Cycle data from prepped data attribute Static Lists :empty - empty list :small - 5 values :medium - 10 values :large - 50 values"},{"ref":"Chunky.Sequence.Test.html#create_sequence_cycle/1","title":"Chunky.Sequence.Test.create_sequence_cycle/1","type":"function","doc":""},{"ref":"Chunky.Sequence.Test.html#create_sequence_doubler/1","title":"Chunky.Sequence.Test.create_sequence_doubler/1","type":"function","doc":""},{"ref":"Chunky.Sequence.Test.html#create_sequence_last_three/1","title":"Chunky.Sequence.Test.create_sequence_last_three/1","type":"function","doc":""},{"ref":"Chunky.Sequence.Test.html#create_sequence_last_two/1","title":"Chunky.Sequence.Test.create_sequence_last_two/1","type":"function","doc":""},{"ref":"Chunky.Sequence.Test.html#create_sequence_list_empty/1","title":"Chunky.Sequence.Test.create_sequence_list_empty/1","type":"function","doc":""},{"ref":"Chunky.Sequence.Test.html#create_sequence_list_large/1","title":"Chunky.Sequence.Test.create_sequence_list_large/1","type":"function","doc":""},{"ref":"Chunky.Sequence.Test.html#create_sequence_list_medium/1","title":"Chunky.Sequence.Test.create_sequence_list_medium/1","type":"function","doc":""},{"ref":"Chunky.Sequence.Test.html#create_sequence_list_small/1","title":"Chunky.Sequence.Test.create_sequence_list_small/1","type":"function","doc":""},{"ref":"Chunky.Sequence.Test.html#create_sequence_whole_numbers/1","title":"Chunky.Sequence.Test.create_sequence_whole_numbers/1","type":"function","doc":""},{"ref":"Chunky.Sequence.Test.html#seq_cycle/2","title":"Chunky.Sequence.Test.seq_cycle/2","type":"function","doc":""},{"ref":"Chunky.Sequence.Test.html#seq_last_three/4","title":"Chunky.Sequence.Test.seq_last_three/4","type":"function","doc":""},{"ref":"readme.html","title":"Chunky","type":"extras","doc":"Chunky Fractions, Sequences, 2D Grids, and Enumeration manipulations in Elixir. iex&gt; Chunky.permutations(&quot;😀🤷🏽‍♀️⭐️&quot;) [ &quot;😀🤷🏽‍♀️⭐️&quot;, &quot;😀⭐️🤷🏽‍♀️&quot;, &quot;🤷🏽‍♀️😀⭐️&quot;, &quot;🤷🏽‍♀️⭐️😀&quot;, &quot;⭐️😀🤷🏽‍♀️&quot;, &quot;⭐️🤷🏽‍♀️😀&quot; ] iex&gt; Chunky.Math.is_prime?(30762542250301270692051460539586166927291732754961) true iex&gt; Chunky.combinations(1..4, 3) [[1, 2, 3], [1, 2, 4], [1, 3, 4], [2, 3, 4]] iex&gt; Chunky.Sequence.create(Chunky.Sequence.OEIS, :a000045) |&gt; Chunky.Sequence.take!(10) [0, 1, 1, 2, 3, 5, 8, 13, 21, 34] iex&gt; Chunky.Fraction.power(Chunky.Fraction.new(7, 32), Chunky.Fraction.new(30, 5)) %Chunky.Fraction{num: 117649, den: 1073741824} iex&gt; Chunky.Fraction.power(Chunky.Fraction.new(7, 32), Chunky.Fraction.new(30, 5)) |&gt; IO.puts() 117649/1073741824 iex&gt; Chunky.Math.prime_factors(3217644767340672907899084554130) [1, 2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71, 73, 79]"},{"ref":"readme.html#installation","title":"Chunky - Installation","type":"extras","doc":"Install by adding chunky to your list of dependencies in mix.exs: def deps do [ {:chunky, &quot;~&gt; 0.9.0&quot;} ] end Chunky documentation can be found on Hexdocs at https://hexdocs.pm/chunky."},{"ref":"readme.html#documentation","title":"Chunky - Documentation","type":"extras","doc":"Fractions Math Sequences Grids Combinitorics"}]